
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef segloc_ERROR_H
#define segloc_ERROR_H

#include "h2errorLib.h"
#include "genom/genomError.h"

#define M_segloc    (3330)

/* -- MODULES ERRORS -------------------------------------------------- */

/* demo errors */
#define S_segloc_BAD_PARAMS           H2_ENCODE_ERR(M_segloc    , 1)
#define S_segloc_ERROR                H2_ENCODE_ERR(M_segloc    , 2)
#define S_segloc_SEG_NOT_FOUND        H2_ENCODE_ERR(M_segloc    , 3)
#define S_segloc_TOO_MANY_SEGS_IN_MAP H2_ENCODE_ERR(M_segloc    , 4)
#define S_segloc_POSTER_NOT_FOUND     H2_ENCODE_ERR(M_segloc    , 5)
#define S_segloc_SERVER_FAILED        H2_ENCODE_ERR(M_segloc    , 6)
#define S_segloc_FILE_NOT_FOUND       H2_ENCODE_ERR(M_segloc    , 7)
#define S_segloc_FAILED               H2_ENCODE_ERR(M_segloc    , 8)
#define S_segloc_SEVERAL_SOLUTIONS    H2_ENCODE_ERR(M_segloc    , 9)
#define S_segloc_SEG_FAILED           H2_ENCODE_ERR(M_segloc    , 10)
#define S_segloc_BIG_JUMP             H2_ENCODE_ERR(M_segloc    , 11)
#define S_segloc_PARTIAL_LOC          H2_ENCODE_ERR(M_segloc    , 12)
#define S_segloc_LOC_FAILED           H2_ENCODE_ERR(M_segloc    , 13)
#define S_segloc_INIT_FAILED          H2_ENCODE_ERR(M_segloc    , 14)


/* std errors */
#define S_segloc_stdGenoM_ACTIVITY_INTERRUPTED       218293249   /* 3330<<16 | 0x8000 | 100<<8 | 1 */
#define S_segloc_stdGenoM_TOO_MANY_ACTIVITIES        218293250   /* 3330<<16 | 0x8000 | 100<<8 | 2 */
#define S_segloc_stdGenoM_ACTIVITY_FAILED            218293251   /* 3330<<16 | 0x8000 | 100<<8 | 3 */
#define S_segloc_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY 218293252   /* 3330<<16 | 0x8000 | 100<<8 | 4 */
#define S_segloc_stdGenoM_UNKNOWN_ACTIVITY           218293253   /* 3330<<16 | 0x8000 | 100<<8 | 5 */
#define S_segloc_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION 218293254   /* 3330<<16 | 0x8000 | 100<<8 | 6 */
#define S_segloc_stdGenoM_SYSTEM_ERROR               218293255   /* 3330<<16 | 0x8000 | 100<<8 | 7 */
#define S_segloc_stdGenoM_ACTIVITY_ALREADY_ENDED     218293256   /* 3330<<16 | 0x8000 | 100<<8 | 8 */
#define S_segloc_stdGenoM_WAIT_INIT_RQST             218293257   /* 3330<<16 | 0x8000 | 100<<8 | 9 */
#define S_segloc_stdGenoM_CONTROL_CODEL_ERROR        218293258   /* 3330<<16 | 0x8000 | 100<<8 | 10 */
#define S_segloc_stdGenoM_EXEC_TASK_SUSPENDED        218293259   /* 3330<<16 | 0x8000 | 100<<8 | 11 */
#define S_segloc_stdGenoM_BAD_BLOCK_TYPE             218293260   /* 3330<<16 | 0x8000 | 100<<8 | 12 */
#define S_segloc_stdGenoM_BAD_POSTER_TYPE            218293261   /* 3330<<16 | 0x8000 | 100<<8 | 13 */



/* static H2_ERROR[] */
#define SEGLOC_H2_ERR_MSGS {\
    {"BAD_PARAMS", 1}, \
    {"ERROR", 2},\
    {"SEG_NOT_FOUND", 3},\
    {"TOO_MANY_SEGS_IN_MAP", 4},\
    {"POSTER_NOT_FOUND", 5},\
    {"SERVER_FAILED", 6},\
    {"FILE_NOT_FOUND", 7},\
    {"FAILED", 8},\
    {"SEVERAL_SOLUTIONS", 9},\
    {"SEG_FAILED", 10},\
    {"BIG_JUMP", 11},\
    {"PARTIAL_LOC", 12},\
    {"LOC_FAILED", 13},\
    {"INIT_FAILED", 14},\
}

#ifdef __cplusplus
extern "C" {
#endif

extern int seglocRecordH2errMsgs(void);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
