
/* 
 * Copyright (c) 1993-2003,2012 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef segloc_MSG_LIB_H
#define segloc_MSG_LIB_H

#include "portLib.h"
#include "csLib.h"
#include "posterLib.h"
 
#include "seglocType.h"

#define TIME_WAIT_REPLY           /*2000*/ 0
 



/*----------- Tailles des messages et boites aux lettres  ----------*/

/* Taille du buffer utilise dans la bal pour un mesage de taille size
 * (cf servMbox pour UNIX et h2rgnLib pour VXWORKS )
 */


#define BUF_SIZE(size) \
   (size + 4 - (size & 3) + sizeof(LETTER_HDR) + 8)

/**
 ** Boite aux lettres reception requetes 
 **/
#define  SEGLOC_MBOX_NAME                  genomInstanceName("segloc")

#define  SEGLOC_MAX_RQST_SIZE              392

#define  SEGLOC_MBOX_RQST_SIZE       \
 (BUF_SIZE(SEGLOC_MAX_RQST_SIZE) * SERV_NMAX_RQST_ID)

/** 
 ** Taille max repliques (serveur)
 **/
#define  SEGLOC_MAX_INTERMED_REPLY_SIZE   (sizeof(int))

#define  SEGLOC_MAX_REPLY_SIZE             392

/** 
 ** Taille bal clients pour reception repliques 
 **/
#define  SEGLOC_CLIENT_MBOX_REPLY_SIZE   \
((BUF_SIZE(SEGLOC_MAX_REPLY_SIZE) \
   + BUF_SIZE(SEGLOC_MAX_INTERMED_REPLY_SIZE)) \
 * CLIENT_NMAX_RQST_ID)

/*-------------------------- Liste des requetes  -------------------------*/

#define SEGLOC_INIT_RQST 0
#define SEGLOC_GETINIT_RQST 1
#define SEGLOC_SEGMENTATIONON_RQST 2
#define SEGLOC_SEGMENTATIONOFF_RQST 3
#define SEGLOC_GETSEGMENTATIONPARAMS_RQST 4
#define SEGLOC_SETSEGMENTATIONPARAMS_RQST 5
#define SEGLOC_LOCLOCAL_RQST 6
#define SEGLOC_FORCELOCLOCAL_RQST 7
#define SEGLOC_RELOC_RQST 8
#define SEGLOC_LOCONCE_RQST 9
#define SEGLOC_LOCLOOP_RQST 10
#define SEGLOC_LOCDYNAMICMAPLOOP_RQST 11
#define SEGLOC_GETLOCPARAMS_RQST 12
#define SEGLOC_SETLOCPARAMS_RQST 13
#define SEGLOC_SURVLOCKO_RQST 14
#define SEGLOC_SURVLOCOK_RQST 15
#define SEGLOC_STOP_RQST 16
#define SEGLOC_RESETMAINTOBASEFROMRFLEX_RQST 17
#define SEGLOC_LOADMAP_RQST 18
#define SEGLOC_GETMAPFILE_RQST 19
#define SEGLOC_SAVEMAP_RQST 20
#define SEGLOC_CLIPMAP_RQST 21
#define SEGLOC_ADDSEGSINMAP_RQST 22
#define SEGLOC_RESETFRAME_RQST 23
#define SEGLOC_SETNORTHENV_RQST 24
#define SEGLOC_REMOVESEGMENT_RQST 25
#define SEGLOC_MERGESEGMENTS_RQST 26
#define SEGLOC_INTERSECTSEGMENTS_RQST 27
#define SEGLOC_CUTSEGMENT_RQST 28
#define SEGLOC_SETOFFLINEMODE_RQST 29
#define SEGLOC_GETOFFLINEMODEPARAMS_RQST 30
#define SEGLOC_ABORT_RQST 31


/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif

STATUS seglocClientInit (CLIENT_ID *pClientId);

STATUS seglocClientEnd (CLIENT_ID clientId);

int seglocAbortRqstSend (CLIENT_ID clientId, 
			   int *pRqstId,
			   int *activity,
			   int replyTimeOut);

int seglocAbortReplyRcv (CLIENT_ID clientId, 
			   int rqstId, 
			   int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			   int *bilan);

int seglocAbortRqstAndRcv (CLIENT_ID clientId, 
			     int *activity,
			     int *bilan);




extern STATUS seglocInitRqstSend (CLIENT_ID clientId, int *pRqstId,
					 SEGLOC_INIT *(in_initParams),
					 int replyTimeOut);

extern int seglocInitReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int seglocInitRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					SEGLOC_INIT *(in_initParams), 
					
					int *activity, int *bilan);

extern int seglocInitRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					SEGLOC_INIT *(in_initParams), 
					
					int *activity,
					int *bilan);




extern STATUS seglocGetInitRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 
					 int replyTimeOut);

int seglocGetInitReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       SEGLOC_INIT *(out_initParams),
			       int *bilan);

int seglocGetInitRqstAndRcv (CLIENT_ID clientId, 
				  
				 SEGLOC_INIT *(out_initParams),
				 int *bilan);




extern STATUS seglocSegmentationOnRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 
					 int replyTimeOut);

int seglocSegmentationOnReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int seglocSegmentationOnRqstAndRcv (CLIENT_ID clientId, 
				  
				 
				 int *bilan);




extern STATUS seglocSegmentationOffRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 
					 int replyTimeOut);

int seglocSegmentationOffReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int seglocSegmentationOffRqstAndRcv (CLIENT_ID clientId, 
				  
				 
				 int *bilan);




extern STATUS seglocGetSegmentationParamsRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 
					 int replyTimeOut);

int seglocGetSegmentationParamsReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       SEGLOC_SEG_PARAMS *(out_segParams),
			       int *bilan);

int seglocGetSegmentationParamsRqstAndRcv (CLIENT_ID clientId, 
				  
				 SEGLOC_SEG_PARAMS *(out_segParams),
				 int *bilan);




extern STATUS seglocSetSegmentationParamsRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 SEGLOC_SEG_PARAMS *(in_segParams),
					 int replyTimeOut);

int seglocSetSegmentationParamsReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int seglocSetSegmentationParamsRqstAndRcv (CLIENT_ID clientId, 
				 SEGLOC_SEG_PARAMS *(in_segParams), 
				 
				 int *bilan);




extern STATUS seglocLocLocalRqstSend (CLIENT_ID clientId, int *pRqstId,
					 SEGLOC_UNCERTAIN_POS *(in_initPos),
					 int replyTimeOut);

extern int seglocLocLocalReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      SEGLOC_POS *(out_pos),
				      int *activity, int *bilan);


extern int seglocLocLocalRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					SEGLOC_UNCERTAIN_POS *(in_initPos), 
					SEGLOC_POS *(out_pos),
					int *activity, int *bilan);

extern int seglocLocLocalRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					SEGLOC_UNCERTAIN_POS *(in_initPos), 
					SEGLOC_POS *(out_pos),
					int *activity,
					int *bilan);




extern STATUS seglocForceLocLocalRqstSend (CLIENT_ID clientId, int *pRqstId,
					 SEGLOC_UNCERTAIN_POS *(in_initPos),
					 int replyTimeOut);

extern int seglocForceLocLocalReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      SEGLOC_POS *(out_pos),
				      int *activity, int *bilan);


extern int seglocForceLocLocalRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					SEGLOC_UNCERTAIN_POS *(in_initPos), 
					SEGLOC_POS *(out_pos),
					int *activity, int *bilan);

extern int seglocForceLocLocalRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					SEGLOC_UNCERTAIN_POS *(in_initPos), 
					SEGLOC_POS *(out_pos),
					int *activity,
					int *bilan);




extern STATUS seglocReLocRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int seglocReLocReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      SEGLOC_POS *(out_pos),
				      int *activity, int *bilan);


extern int seglocReLocRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					SEGLOC_POS *(out_pos),
					int *activity, int *bilan);

extern int seglocReLocRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					SEGLOC_POS *(out_pos),
					int *activity,
					int *bilan);




extern STATUS seglocLocOnceRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int seglocLocOnceReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      SEGLOC_POS *(out_pos),
				      int *activity, int *bilan);


extern int seglocLocOnceRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					SEGLOC_POS *(out_pos),
					int *activity, int *bilan);

extern int seglocLocOnceRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					SEGLOC_POS *(out_pos),
					int *activity,
					int *bilan);




extern STATUS seglocLocLoopRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int seglocLocLoopReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int seglocLocLoopRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int seglocLocLoopRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS seglocLocDynamicMapLoopRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int seglocLocDynamicMapLoopReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int seglocLocDynamicMapLoopRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int seglocLocDynamicMapLoopRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS seglocGetLocParamsRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 SEGLOC_LOC_MODE *(in_locMode),
					 int replyTimeOut);

int seglocGetLocParamsReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       SEGLOC_LOC_PARAMS *(out_locParamsRqst),
			       int *bilan);

int seglocGetLocParamsRqstAndRcv (CLIENT_ID clientId, 
				 SEGLOC_LOC_MODE *(in_locMode), 
				 SEGLOC_LOC_PARAMS *(out_locParamsRqst),
				 int *bilan);




extern STATUS seglocSetLocParamsRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 SEGLOC_LOC_PARAMS *(in_locParamsRqst),
					 int replyTimeOut);

int seglocSetLocParamsReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int seglocSetLocParamsRqstAndRcv (CLIENT_ID clientId, 
				 SEGLOC_LOC_PARAMS *(in_locParamsRqst), 
				 
				 int *bilan);




extern STATUS seglocSurvLocKORqstSend (CLIENT_ID clientId, int *pRqstId,
					 SEGLOC_UNC *(in_survPosUncertainties),
					 int replyTimeOut);

extern int seglocSurvLocKOReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      SEGLOC_SURV_LOC_REPORT *(out_survLocReport),
				      int *activity, int *bilan);


extern int seglocSurvLocKORqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					SEGLOC_UNC *(in_survPosUncertainties), 
					SEGLOC_SURV_LOC_REPORT *(out_survLocReport),
					int *activity, int *bilan);

extern int seglocSurvLocKORqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					SEGLOC_UNC *(in_survPosUncertainties), 
					SEGLOC_SURV_LOC_REPORT *(out_survLocReport),
					int *activity,
					int *bilan);




extern STATUS seglocSurvLocOKRqstSend (CLIENT_ID clientId, int *pRqstId,
					 SEGLOC_UNC *(in_survPosUncertainties),
					 int replyTimeOut);

extern int seglocSurvLocOKReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int seglocSurvLocOKRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					SEGLOC_UNC *(in_survPosUncertainties), 
					
					int *activity, int *bilan);

extern int seglocSurvLocOKRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					SEGLOC_UNC *(in_survPosUncertainties), 
					
					int *activity,
					int *bilan);




extern STATUS seglocStopRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 
					 int replyTimeOut);

int seglocStopReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int seglocStopRqstAndRcv (CLIENT_ID clientId, 
				  
				 
				 int *bilan);




extern STATUS seglocResetMainToBaseFromRflexRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int seglocResetMainToBaseFromRflexReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int seglocResetMainToBaseFromRflexRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int seglocResetMainToBaseFromRflexRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS seglocLoadMapRqstSend (CLIENT_ID clientId, int *pRqstId,
					 SEGLOC_FILE_PARAMS *(in_mapFile),
					 int replyTimeOut);

extern int seglocLoadMapReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int seglocLoadMapRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					SEGLOC_FILE_PARAMS *(in_mapFile), 
					
					int *activity, int *bilan);

extern int seglocLoadMapRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					SEGLOC_FILE_PARAMS *(in_mapFile), 
					
					int *activity,
					int *bilan);




extern STATUS seglocGetMapFileRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 
					 int replyTimeOut);

int seglocGetMapFileReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       SEGLOC_FILE_PARAMS *(out_mapFile),
			       int *bilan);

int seglocGetMapFileRqstAndRcv (CLIENT_ID clientId, 
				  
				 SEGLOC_FILE_PARAMS *(out_mapFile),
				 int *bilan);




extern STATUS seglocSaveMapRqstSend (CLIENT_ID clientId, int *pRqstId,
					 SEGLOC_FILE_PARAMS *(in_mapFile),
					 int replyTimeOut);

extern int seglocSaveMapReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int seglocSaveMapRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					SEGLOC_FILE_PARAMS *(in_mapFile), 
					
					int *activity, int *bilan);

extern int seglocSaveMapRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					SEGLOC_FILE_PARAMS *(in_mapFile), 
					
					int *activity,
					int *bilan);




extern STATUS seglocClipMapRqstSend (CLIENT_ID clientId, int *pRqstId,
					 SEGLOC_CLIP_MAP_PARAMS *(in_clipMapParams),
					 int replyTimeOut);

extern int seglocClipMapReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int seglocClipMapRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					SEGLOC_CLIP_MAP_PARAMS *(in_clipMapParams), 
					
					int *activity, int *bilan);

extern int seglocClipMapRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					SEGLOC_CLIP_MAP_PARAMS *(in_clipMapParams), 
					
					int *activity,
					int *bilan);




extern STATUS seglocAddSegsInMapRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int seglocAddSegsInMapReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int seglocAddSegsInMapRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int seglocAddSegsInMapRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS seglocResetFrameRqstSend (CLIENT_ID clientId, int *pRqstId,
					 SEGLOC_START_END_POS *(in_changePositions),
					 int replyTimeOut);

extern int seglocResetFrameReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int seglocResetFrameRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					SEGLOC_START_END_POS *(in_changePositions), 
					
					int *activity, int *bilan);

extern int seglocResetFrameRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					SEGLOC_START_END_POS *(in_changePositions), 
					
					int *activity,
					int *bilan);




extern STATUS seglocSetNorthEnvRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 SEGLOC_COMPASS_ENV *(in_compassEnv),
					 int replyTimeOut);

int seglocSetNorthEnvReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       SEGLOC_COMPASS_RES *(out_compassRes),
			       int *bilan);

int seglocSetNorthEnvRqstAndRcv (CLIENT_ID clientId, 
				 SEGLOC_COMPASS_ENV *(in_compassEnv), 
				 SEGLOC_COMPASS_RES *(out_compassRes),
				 int *bilan);




extern STATUS seglocRemoveSegmentRqstSend (CLIENT_ID clientId, int *pRqstId,
					 SEGLOC_SEG *(in_seg1),
					 int replyTimeOut);

extern int seglocRemoveSegmentReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int seglocRemoveSegmentRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					SEGLOC_SEG *(in_seg1), 
					
					int *activity, int *bilan);

extern int seglocRemoveSegmentRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					SEGLOC_SEG *(in_seg1), 
					
					int *activity,
					int *bilan);




extern STATUS seglocMergeSegmentsRqstSend (CLIENT_ID clientId, int *pRqstId,
					 SEGLOC_2SEGS *(in_segs),
					 int replyTimeOut);

extern int seglocMergeSegmentsReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int seglocMergeSegmentsRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					SEGLOC_2SEGS *(in_segs), 
					
					int *activity, int *bilan);

extern int seglocMergeSegmentsRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					SEGLOC_2SEGS *(in_segs), 
					
					int *activity,
					int *bilan);




extern STATUS seglocIntersectSegmentsRqstSend (CLIENT_ID clientId, int *pRqstId,
					 SEGLOC_2SEGS *(in_segs),
					 int replyTimeOut);

extern int seglocIntersectSegmentsReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int seglocIntersectSegmentsRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					SEGLOC_2SEGS *(in_segs), 
					
					int *activity, int *bilan);

extern int seglocIntersectSegmentsRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					SEGLOC_2SEGS *(in_segs), 
					
					int *activity,
					int *bilan);




extern STATUS seglocCutSegmentRqstSend (CLIENT_ID clientId, int *pRqstId,
					 SEGLOC_CUT_SEG *(in_segCut),
					 int replyTimeOut);

extern int seglocCutSegmentReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int seglocCutSegmentRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					SEGLOC_CUT_SEG *(in_segCut), 
					
					int *activity, int *bilan);

extern int seglocCutSegmentRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					SEGLOC_CUT_SEG *(in_segCut), 
					
					int *activity,
					int *bilan);




extern STATUS seglocSetOfflineModeRqstSend (CLIENT_ID clientId, int *pRqstId,
					 SEGLOC_OFFLINE *(in_offlineParams),
					 int replyTimeOut);

extern int seglocSetOfflineModeReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int seglocSetOfflineModeRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					SEGLOC_OFFLINE *(in_offlineParams), 
					
					int *activity, int *bilan);

extern int seglocSetOfflineModeRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					SEGLOC_OFFLINE *(in_offlineParams), 
					
					int *activity,
					int *bilan);




extern STATUS seglocGetOfflineModeParamsRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 
					 int replyTimeOut);

int seglocGetOfflineModeParamsReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       SEGLOC_OFFLINE *(out_offlineParams),
			       int *bilan);

int seglocGetOfflineModeParamsRqstAndRcv (CLIENT_ID clientId, 
				  
				 SEGLOC_OFFLINE *(out_offlineParams),
				 int *bilan);


#ifdef __cplusplus
}
#endif
#endif /* segloc_MSG_LIB_H */

