
/* 
 * Copyright (c) 1993-2003,2012 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef segloc_POSTER_LIB_H
#define segloc_POSTER_LIB_H

#include "posterLib.h"
#include "genom/genom.h"

/* Types definis ou utilises par le module */
#include "seglocType.h"
#include "seglocError.h"

/* 
 * Definition de la SDI_C 
*/
typedef struct {
  CNTRL_TASK_DESCRIPTION cntrlTask;
  EXEC_TASK_DESCRIPTION execTaskTab[SEGLOC_NB_EXEC_TASK];
  ACTIVITY_DESCRIPTION activityTab[MAX_ACTIVITIES];
} SEGLOC_CNTRL_STR;

/* For consistency with other posters */
typedef SEGLOC_CNTRL_STR SEGLOC_CNTRL_POSTER_STR;
 
/* 
 * Definition des structures de posters
 */
#include "seglocPosterLibStruct.h"



/* Posters */
#define SEGLOC_CNTRL_POSTER_NAME genomInstanceSuffixName("segloc", "Cntrl")
#define SEGLOC_LOC_POSTER_NAME genomInstanceSuffixName("segloc", "Loc")
#define SEGLOC_MISC_POSTER_NAME genomInstanceSuffixName("segloc", "Misc")
#define SEGLOC_MEPOS_POSTER_NAME genomInstanceSuffixName("segloc", "MEPos")
#define SEGLOC_MAP_POSTER_NAME genomInstanceSuffixName("segloc", "Map")
#define SEGLOC_SEGS_POSTER_NAME genomInstanceSuffixName("segloc", "Segs")
#define SEGLOC_ASPECT_POSTER_NAME genomInstanceSuffixName("segloc", "Aspect")


/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif
extern STATUS seglocPosterInit ( void );
extern POSTER_ID seglocCntrlPosterID ();
extern STATUS seglocCntrlPosterRead ( SEGLOC_CNTRL_STR *seglocCntrlStrId );
extern STATUS seglocCntrlPosterInit ( void );
extern STATUS seglocCntrlInstancePosterRead(const char *name, SEGLOC_CNTRL_STR *seglocCntrlStrId);
extern STATUS seglocLocPosterInit ( void );
extern POSTER_ID seglocLocPosterID ( void );
extern STATUS seglocLocPosterRead ( SEGLOC_LOC_POSTER_STR *x );
extern STATUS seglocLocInstancePosterRead ( const char *, SEGLOC_LOC_POSTER_STR * );
extern STATUS seglocLocTransfPosterRead ( SEGLOC_POS_VAR *Transf );
extern STATUS seglocLocTransfInstancePosterRead( const char *, SEGLOC_POS_VAR * );
extern STATUS seglocLocReportPosterRead ( SEGLOC_LOC_REPORT *Report );
extern STATUS seglocLocReportInstancePosterRead( const char *, SEGLOC_LOC_REPORT * );
extern STATUS seglocMiscPosterInit ( void );
extern POSTER_ID seglocMiscPosterID ( void );
extern STATUS seglocMiscPosterRead ( SEGLOC_MISC_POSTER_STR *x );
extern STATUS seglocMiscInstancePosterRead ( const char *, SEGLOC_MISC_POSTER_STR * );
extern STATUS seglocMiscSickLocoPosPosterRead ( SEGLOC_POS_VAR_SPEED *SickLocoPos );
extern STATUS seglocMiscSickLocoPosInstancePosterRead( const char *, SEGLOC_POS_VAR_SPEED * );
extern STATUS seglocMiscSickSeglocPosPosterRead ( SEGLOC_POS_VAR *SickSeglocPos );
extern STATUS seglocMiscSickSeglocPosInstancePosterRead( const char *, SEGLOC_POS_VAR * );
extern STATUS seglocMiscCurrentLocoPosPosterRead ( SEGLOC_POS_VAR_SPEED *CurrentLocoPos );
extern STATUS seglocMiscCurrentLocoPosInstancePosterRead( const char *, SEGLOC_POS_VAR_SPEED * );
extern STATUS seglocMiscCurrentSeglocPosPosterRead ( SEGLOC_POS_VAR *CurrentSeglocPos );
extern STATUS seglocMiscCurrentSeglocPosInstancePosterRead( const char *, SEGLOC_POS_VAR * );
extern STATUS seglocMiscseglocTimesPosterRead ( SEGLOC_TIMES *seglocTimes );
extern STATUS seglocMiscseglocTimesInstancePosterRead( const char *, SEGLOC_TIMES * );
extern STATUS seglocMiscSickLocoUncertaintiesPosterRead ( SEGLOC_UNC *SickLocoUncertainties );
extern STATUS seglocMiscSickLocoUncertaintiesInstancePosterRead( const char *, SEGLOC_UNC * );
extern STATUS seglocMiscSickSeglocUncertaintiesPosterRead ( SEGLOC_UNC *SickSeglocUncertainties );
extern STATUS seglocMiscSickSeglocUncertaintiesInstancePosterRead( const char *, SEGLOC_UNC * );
extern STATUS seglocMiscStatPosterRead ( SEGLOC_STAT *Stat );
extern STATUS seglocMiscStatInstancePosterRead( const char *, SEGLOC_STAT * );
extern STATUS seglocMiscCompassPosterRead ( SEGLOC_COMPASS_STR *Compass );
extern STATUS seglocMiscCompassInstancePosterRead( const char *, SEGLOC_COMPASS_STR * );
extern STATUS seglocMEPosPosterInit ( void );
extern POSTER_ID seglocMEPosPosterID ( void );
extern STATUS seglocMEPosPosterRead ( SEGLOC_MEPOS_POSTER_STR *x );
extern STATUS seglocMEPosInstancePosterRead ( const char *, SEGLOC_MEPOS_POSTER_STR * );
extern STATUS seglocMEPosPosPosterRead ( POM_ME_POS *Pos );
extern STATUS seglocMEPosPosInstancePosterRead( const char *, POM_ME_POS * );
extern STATUS seglocMapPosterInit ( void );
extern POSTER_ID seglocMapPosterID ( void );
extern STATUS seglocMapPosterRead ( SEGLOC_MAP_POSTER_STR *x );
extern STATUS seglocMapInstancePosterRead ( const char *, SEGLOC_MAP_POSTER_STR * );
extern STATUS seglocMapMapPosterRead ( SEGLOC_MAP *Map );
extern STATUS seglocMapMapInstancePosterRead( const char *, SEGLOC_MAP * );
extern STATUS seglocSegsPosterInit ( void );
extern POSTER_ID seglocSegsPosterID ( void );
extern STATUS seglocSegsPosterRead ( SEGLOC_SEGS_POSTER_STR *x );
extern STATUS seglocSegsInstancePosterRead ( const char *, SEGLOC_SEGS_POSTER_STR * );
extern STATUS seglocSegsSegsPosterRead ( SEGLOC_ACQ_SEGS *Segs );
extern STATUS seglocSegsSegsInstancePosterRead( const char *, SEGLOC_ACQ_SEGS * );
extern STATUS seglocAspectPosterInit ( void );
extern POSTER_ID seglocAspectPosterID ( void );
extern STATUS seglocAspectPosterRead ( SEGLOC_ASPECT_POSTER_STR *x );
extern STATUS seglocAspectInstancePosterRead ( const char *, SEGLOC_ASPECT_POSTER_STR * );
extern STATUS seglocAspectAspectPosterRead ( SEGLOC_ASPECT_SEGS *Aspect );
extern STATUS seglocAspectAspectInstancePosterRead( const char *, SEGLOC_ASPECT_SEGS * );
#ifdef __cplusplus
}
#endif
#endif

