
/* 
 * Copyright (c) 2003 LAAS/CNRS
 * Sara Fleury
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef SEGLOC_PRINTXML_H
#define SEGLOC_PRINTXML_H

#include "genom/printScan.h"
#include "genom/printXMLProto.h"

/* Structures definies par d'autres modules */

#include "server/sickPrintXML.h"

#include "server/pomPrintXML.h"


#include "seglocPosterLib.h"

/* Prototypes */
extern void printXML_struct_SEGLOC_ASPECT_POSTER_STR ( FILE *out, char *name,
     struct SEGLOC_ASPECT_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_SEGS_POSTER_STR ( FILE *out, char *name,
     struct SEGLOC_SEGS_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_MAP_POSTER_STR ( FILE *out, char *name,
     struct SEGLOC_MAP_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_MEPOS_POSTER_STR ( FILE *out, char *name,
     struct SEGLOC_MEPOS_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_MISC_POSTER_STR ( FILE *out, char *name,
     struct SEGLOC_MISC_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_LOC_POSTER_STR ( FILE *out, char *name,
     struct SEGLOC_LOC_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_STR ( FILE *out, char *name,
     struct SEGLOC_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_MAP ( FILE *out, char *name,
     struct SEGLOC_MAP *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_MAP_HEADER ( FILE *out, char *name,
     struct SEGLOC_MAP_HEADER *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_MATCHED_SEGS ( FILE *out, char *name,
     struct SEGLOC_MATCHED_SEGS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_MATCHED_SEG ( FILE *out, char *name,
     struct SEGLOC_MATCHED_SEG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_MATCHED_SEG_HEADER ( FILE *out, char *name,
     struct SEGLOC_MATCHED_SEG_HEADER *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_ASPECT_SEGS ( FILE *out, char *name,
     struct SEGLOC_ASPECT_SEGS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_ACQ_SEGS ( FILE *out, char *name,
     struct SEGLOC_ACQ_SEGS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_SEG_HEADER ( FILE *out, char *name,
     struct SEGLOC_SEG_HEADER *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_SEG_PARAMS ( FILE *out, char *name,
     struct SEGLOC_SEG_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_MAP_EDIT ( FILE *out, char *name,
     struct SEGLOC_MAP_EDIT *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_CUT_SEG ( FILE *out, char *name,
     struct SEGLOC_CUT_SEG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_2SEGS ( FILE *out, char *name,
     struct SEGLOC_2SEGS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_SEG ( FILE *out, char *name,
     struct SEGLOC_SEG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_COMPASS_STR ( FILE *out, char *name,
     struct SEGLOC_COMPASS_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_COMPASS_RES ( FILE *out, char *name,
     struct SEGLOC_COMPASS_RES *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_COMPASS_ENV ( FILE *out, char *name,
     struct SEGLOC_COMPASS_ENV *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_OFFLINE ( FILE *out, char *name,
     struct SEGLOC_OFFLINE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_STAT ( FILE *out, char *name,
     struct SEGLOC_STAT *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_STATE ( FILE *out, char *name,
     struct SEGLOC_STATE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_SEGLOC_SURV_LOC_REPORT ( FILE *out, char *name,
     enum SEGLOC_SURV_LOC_REPORT *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_TIMES ( FILE *out, char *name,
     struct SEGLOC_TIMES *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_LOC_REPORT ( FILE *out, char *name,
     struct SEGLOC_LOC_REPORT *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_SEGLOC_CONFIDENCE_ATTRIBUTES ( FILE *out, char *name,
     enum SEGLOC_CONFIDENCE_ATTRIBUTES *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_SEGLOC_LOC_QUALITY ( FILE *out, char *name,
     enum SEGLOC_LOC_QUALITY *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_LOC_PARAMS ( FILE *out, char *name,
     struct SEGLOC_LOC_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_SEGLOC_UPDATE_LOCO ( FILE *out, char *name,
     enum SEGLOC_UPDATE_LOCO *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_SEGLOC_LOC_MODE ( FILE *out, char *name,
     enum SEGLOC_LOC_MODE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_START_END_POS ( FILE *out, char *name,
     struct SEGLOC_START_END_POS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_UNCERTAIN_POS ( FILE *out, char *name,
     struct SEGLOC_UNCERTAIN_POS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_POS_VAR_SPEED ( FILE *out, char *name,
     struct SEGLOC_POS_VAR_SPEED *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_POS_VAR ( FILE *out, char *name,
     struct SEGLOC_POS_VAR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_VARIANCES ( FILE *out, char *name,
     struct SEGLOC_VARIANCES *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_POS_SPEED ( FILE *out, char *name,
     struct SEGLOC_POS_SPEED *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_SPEED ( FILE *out, char *name,
     struct SEGLOC_SPEED *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_UNC ( FILE *out, char *name,
     struct SEGLOC_UNC *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_POS ( FILE *out, char *name,
     struct SEGLOC_POS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_CLIP_MAP_PARAMS ( FILE *out, char *name,
     struct SEGLOC_CLIP_MAP_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_SEGLOC_CLIP_MODE ( FILE *out, char *name,
     enum SEGLOC_CLIP_MODE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_INIT ( FILE *out, char *name,
     struct SEGLOC_INIT *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_SEGLOC_FILE_PARAMS ( FILE *out, char *name,
     struct SEGLOC_FILE_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_SEGLOC_BOOL ( FILE *out, char *name,
     enum SEGLOC_BOOL *x,
     int indent, int nDim, int *dims, FILE *in );

/* ======================== PRINT DES TYPEDEF ============================= */

extern void printXML_SEGLOC_BOOL ( FILE *out, char *name,
     SEGLOC_BOOL *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_FILE_PARAMS ( FILE *out, char *name,
     SEGLOC_FILE_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_INIT ( FILE *out, char *name,
     SEGLOC_INIT *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_CLIP_MODE ( FILE *out, char *name,
     SEGLOC_CLIP_MODE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_CLIP_MAP_PARAMS ( FILE *out, char *name,
     SEGLOC_CLIP_MAP_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_POS ( FILE *out, char *name,
     SEGLOC_POS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_UNC ( FILE *out, char *name,
     SEGLOC_UNC *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_SPEED ( FILE *out, char *name,
     SEGLOC_SPEED *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_POS_SPEED ( FILE *out, char *name,
     SEGLOC_POS_SPEED *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_VARIANCES ( FILE *out, char *name,
     SEGLOC_VARIANCES *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_POS_VAR ( FILE *out, char *name,
     SEGLOC_POS_VAR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_POS_VAR_SPEED ( FILE *out, char *name,
     SEGLOC_POS_VAR_SPEED *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_UNCERTAIN_POS ( FILE *out, char *name,
     SEGLOC_UNCERTAIN_POS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_START_END_POS ( FILE *out, char *name,
     SEGLOC_START_END_POS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_LOC_MODE ( FILE *out, char *name,
     SEGLOC_LOC_MODE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_UPDATE_LOCO ( FILE *out, char *name,
     SEGLOC_UPDATE_LOCO *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_LOC_PARAMS ( FILE *out, char *name,
     SEGLOC_LOC_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_LOC_QUALITY ( FILE *out, char *name,
     SEGLOC_LOC_QUALITY *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_CONFIDENCE_ATTRIBUTES ( FILE *out, char *name,
     SEGLOC_CONFIDENCE_ATTRIBUTES *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_LOC_REPORT ( FILE *out, char *name,
     SEGLOC_LOC_REPORT *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_TIMES ( FILE *out, char *name,
     SEGLOC_TIMES *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_SURV_LOC_REPORT ( FILE *out, char *name,
     SEGLOC_SURV_LOC_REPORT *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_STATE ( FILE *out, char *name,
     SEGLOC_STATE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_STAT ( FILE *out, char *name,
     SEGLOC_STAT *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_OFFLINE ( FILE *out, char *name,
     SEGLOC_OFFLINE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_COMPASS_ENV ( FILE *out, char *name,
     SEGLOC_COMPASS_ENV *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_COMPASS_RES ( FILE *out, char *name,
     SEGLOC_COMPASS_RES *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_COMPASS_STR ( FILE *out, char *name,
     SEGLOC_COMPASS_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_SEG ( FILE *out, char *name,
     SEGLOC_SEG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_2SEGS ( FILE *out, char *name,
     SEGLOC_2SEGS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_CUT_SEG ( FILE *out, char *name,
     SEGLOC_CUT_SEG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_MAP_EDIT ( FILE *out, char *name,
     SEGLOC_MAP_EDIT *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_SEG_PARAMS ( FILE *out, char *name,
     SEGLOC_SEG_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_SEG_HEADER ( FILE *out, char *name,
     SEGLOC_SEG_HEADER *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_ACQ_SEGS ( FILE *out, char *name,
     SEGLOC_ACQ_SEGS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_ASPECT_SEGS ( FILE *out, char *name,
     SEGLOC_ASPECT_SEGS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_MATCHED_SEG_HEADER ( FILE *out, char *name,
     SEGLOC_MATCHED_SEG_HEADER *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_MATCHED_SEG ( FILE *out, char *name,
     SEGLOC_MATCHED_SEG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_MATCHED_SEGS ( FILE *out, char *name,
     SEGLOC_MATCHED_SEGS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_MAP_HEADER ( FILE *out, char *name,
     SEGLOC_MAP_HEADER *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_MAP ( FILE *out, char *name,
     SEGLOC_MAP *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_STR ( FILE *out, char *name,
     SEGLOC_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_LOC_POSTER_STR ( FILE *out, char *name,
     SEGLOC_LOC_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_MISC_POSTER_STR ( FILE *out, char *name,
     SEGLOC_MISC_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_MEPOS_POSTER_STR ( FILE *out, char *name,
     SEGLOC_MEPOS_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_MAP_POSTER_STR ( FILE *out, char *name,
     SEGLOC_MAP_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_SEGS_POSTER_STR ( FILE *out, char *name,
     SEGLOC_SEGS_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_SEGLOC_ASPECT_POSTER_STR ( FILE *out, char *name,
     SEGLOC_ASPECT_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );

#endif /* SEGLOC_PRINT_XML_H */

