
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef SEGLOC_SCAN_H
#define SEGLOC_SCAN_H

#include "genom/printScan.h"

/* Structures definies par d'autres modules */

#include "server/sickScan.h"

#include "server/pomScan.h"


/* Structures du module */
#include "seglocPosterLib.h"

/* Prototypes */
#ifdef __cplusplus
extern "C" {
#endif
extern int scan_struct_SEGLOC_ASPECT_POSTER_STR ( FILE *in, FILE *out,
       struct SEGLOC_ASPECT_POSTER_STR *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_SEGS_POSTER_STR ( FILE *in, FILE *out,
       struct SEGLOC_SEGS_POSTER_STR *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_MAP_POSTER_STR ( FILE *in, FILE *out,
       struct SEGLOC_MAP_POSTER_STR *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_MEPOS_POSTER_STR ( FILE *in, FILE *out,
       struct SEGLOC_MEPOS_POSTER_STR *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_MISC_POSTER_STR ( FILE *in, FILE *out,
       struct SEGLOC_MISC_POSTER_STR *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_LOC_POSTER_STR ( FILE *in, FILE *out,
       struct SEGLOC_LOC_POSTER_STR *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_STR ( FILE *in, FILE *out,
       struct SEGLOC_STR *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_MAP ( FILE *in, FILE *out,
       struct SEGLOC_MAP *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_MAP_HEADER ( FILE *in, FILE *out,
       struct SEGLOC_MAP_HEADER *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_MATCHED_SEGS ( FILE *in, FILE *out,
       struct SEGLOC_MATCHED_SEGS *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_MATCHED_SEG ( FILE *in, FILE *out,
       struct SEGLOC_MATCHED_SEG *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_MATCHED_SEG_HEADER ( FILE *in, FILE *out,
       struct SEGLOC_MATCHED_SEG_HEADER *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_ASPECT_SEGS ( FILE *in, FILE *out,
       struct SEGLOC_ASPECT_SEGS *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_ACQ_SEGS ( FILE *in, FILE *out,
       struct SEGLOC_ACQ_SEGS *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_SEG_HEADER ( FILE *in, FILE *out,
       struct SEGLOC_SEG_HEADER *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_SEG_PARAMS ( FILE *in, FILE *out,
       struct SEGLOC_SEG_PARAMS *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_MAP_EDIT ( FILE *in, FILE *out,
       struct SEGLOC_MAP_EDIT *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_CUT_SEG ( FILE *in, FILE *out,
       struct SEGLOC_CUT_SEG *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_2SEGS ( FILE *in, FILE *out,
       struct SEGLOC_2SEGS *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_SEG ( FILE *in, FILE *out,
       struct SEGLOC_SEG *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_COMPASS_STR ( FILE *in, FILE *out,
       struct SEGLOC_COMPASS_STR *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_COMPASS_RES ( FILE *in, FILE *out,
       struct SEGLOC_COMPASS_RES *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_COMPASS_ENV ( FILE *in, FILE *out,
       struct SEGLOC_COMPASS_ENV *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_OFFLINE ( FILE *in, FILE *out,
       struct SEGLOC_OFFLINE *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_STAT ( FILE *in, FILE *out,
       struct SEGLOC_STAT *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_STATE ( FILE *in, FILE *out,
       struct SEGLOC_STATE *x, int indent, int nDim, int *dims );
extern int scan_enum_SEGLOC_SURV_LOC_REPORT ( FILE *in, FILE *out,
       enum SEGLOC_SURV_LOC_REPORT *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_TIMES ( FILE *in, FILE *out,
       struct SEGLOC_TIMES *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_LOC_REPORT ( FILE *in, FILE *out,
       struct SEGLOC_LOC_REPORT *x, int indent, int nDim, int *dims );
extern int scan_enum_SEGLOC_CONFIDENCE_ATTRIBUTES ( FILE *in, FILE *out,
       enum SEGLOC_CONFIDENCE_ATTRIBUTES *x, int indent, int nDim, int *dims );
extern int scan_enum_SEGLOC_LOC_QUALITY ( FILE *in, FILE *out,
       enum SEGLOC_LOC_QUALITY *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_LOC_PARAMS ( FILE *in, FILE *out,
       struct SEGLOC_LOC_PARAMS *x, int indent, int nDim, int *dims );
extern int scan_enum_SEGLOC_UPDATE_LOCO ( FILE *in, FILE *out,
       enum SEGLOC_UPDATE_LOCO *x, int indent, int nDim, int *dims );
extern int scan_enum_SEGLOC_LOC_MODE ( FILE *in, FILE *out,
       enum SEGLOC_LOC_MODE *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_START_END_POS ( FILE *in, FILE *out,
       struct SEGLOC_START_END_POS *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_UNCERTAIN_POS ( FILE *in, FILE *out,
       struct SEGLOC_UNCERTAIN_POS *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_POS_VAR_SPEED ( FILE *in, FILE *out,
       struct SEGLOC_POS_VAR_SPEED *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_POS_VAR ( FILE *in, FILE *out,
       struct SEGLOC_POS_VAR *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_VARIANCES ( FILE *in, FILE *out,
       struct SEGLOC_VARIANCES *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_POS_SPEED ( FILE *in, FILE *out,
       struct SEGLOC_POS_SPEED *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_SPEED ( FILE *in, FILE *out,
       struct SEGLOC_SPEED *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_UNC ( FILE *in, FILE *out,
       struct SEGLOC_UNC *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_POS ( FILE *in, FILE *out,
       struct SEGLOC_POS *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_CLIP_MAP_PARAMS ( FILE *in, FILE *out,
       struct SEGLOC_CLIP_MAP_PARAMS *x, int indent, int nDim, int *dims );
extern int scan_enum_SEGLOC_CLIP_MODE ( FILE *in, FILE *out,
       enum SEGLOC_CLIP_MODE *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_INIT ( FILE *in, FILE *out,
       struct SEGLOC_INIT *x, int indent, int nDim, int *dims );
extern int scan_struct_SEGLOC_FILE_PARAMS ( FILE *in, FILE *out,
       struct SEGLOC_FILE_PARAMS *x, int indent, int nDim, int *dims );
extern int scan_enum_SEGLOC_BOOL ( FILE *in, FILE *out,
       enum SEGLOC_BOOL *x, int indent, int nDim, int *dims );

/* ======================== SCAN DES TYPEDEF ============================= */

extern int scan_SEGLOC_BOOL ( FILE *in, FILE *out,
       SEGLOC_BOOL *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_FILE_PARAMS ( FILE *in, FILE *out,
       SEGLOC_FILE_PARAMS *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_INIT ( FILE *in, FILE *out,
       SEGLOC_INIT *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_CLIP_MODE ( FILE *in, FILE *out,
       SEGLOC_CLIP_MODE *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_CLIP_MAP_PARAMS ( FILE *in, FILE *out,
       SEGLOC_CLIP_MAP_PARAMS *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_POS ( FILE *in, FILE *out,
       SEGLOC_POS *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_UNC ( FILE *in, FILE *out,
       SEGLOC_UNC *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_SPEED ( FILE *in, FILE *out,
       SEGLOC_SPEED *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_POS_SPEED ( FILE *in, FILE *out,
       SEGLOC_POS_SPEED *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_VARIANCES ( FILE *in, FILE *out,
       SEGLOC_VARIANCES *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_POS_VAR ( FILE *in, FILE *out,
       SEGLOC_POS_VAR *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_POS_VAR_SPEED ( FILE *in, FILE *out,
       SEGLOC_POS_VAR_SPEED *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_UNCERTAIN_POS ( FILE *in, FILE *out,
       SEGLOC_UNCERTAIN_POS *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_START_END_POS ( FILE *in, FILE *out,
       SEGLOC_START_END_POS *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_LOC_MODE ( FILE *in, FILE *out,
       SEGLOC_LOC_MODE *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_UPDATE_LOCO ( FILE *in, FILE *out,
       SEGLOC_UPDATE_LOCO *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_LOC_PARAMS ( FILE *in, FILE *out,
       SEGLOC_LOC_PARAMS *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_LOC_QUALITY ( FILE *in, FILE *out,
       SEGLOC_LOC_QUALITY *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_CONFIDENCE_ATTRIBUTES ( FILE *in, FILE *out,
       SEGLOC_CONFIDENCE_ATTRIBUTES *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_LOC_REPORT ( FILE *in, FILE *out,
       SEGLOC_LOC_REPORT *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_TIMES ( FILE *in, FILE *out,
       SEGLOC_TIMES *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_SURV_LOC_REPORT ( FILE *in, FILE *out,
       SEGLOC_SURV_LOC_REPORT *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_STATE ( FILE *in, FILE *out,
       SEGLOC_STATE *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_STAT ( FILE *in, FILE *out,
       SEGLOC_STAT *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_OFFLINE ( FILE *in, FILE *out,
       SEGLOC_OFFLINE *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_COMPASS_ENV ( FILE *in, FILE *out,
       SEGLOC_COMPASS_ENV *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_COMPASS_RES ( FILE *in, FILE *out,
       SEGLOC_COMPASS_RES *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_COMPASS_STR ( FILE *in, FILE *out,
       SEGLOC_COMPASS_STR *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_SEG ( FILE *in, FILE *out,
       SEGLOC_SEG *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_2SEGS ( FILE *in, FILE *out,
       SEGLOC_2SEGS *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_CUT_SEG ( FILE *in, FILE *out,
       SEGLOC_CUT_SEG *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_MAP_EDIT ( FILE *in, FILE *out,
       SEGLOC_MAP_EDIT *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_SEG_PARAMS ( FILE *in, FILE *out,
       SEGLOC_SEG_PARAMS *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_SEG_HEADER ( FILE *in, FILE *out,
       SEGLOC_SEG_HEADER *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_ACQ_SEGS ( FILE *in, FILE *out,
       SEGLOC_ACQ_SEGS *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_ASPECT_SEGS ( FILE *in, FILE *out,
       SEGLOC_ASPECT_SEGS *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_MATCHED_SEG_HEADER ( FILE *in, FILE *out,
       SEGLOC_MATCHED_SEG_HEADER *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_MATCHED_SEG ( FILE *in, FILE *out,
       SEGLOC_MATCHED_SEG *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_MATCHED_SEGS ( FILE *in, FILE *out,
       SEGLOC_MATCHED_SEGS *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_MAP_HEADER ( FILE *in, FILE *out,
       SEGLOC_MAP_HEADER *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_MAP ( FILE *in, FILE *out,
       SEGLOC_MAP *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_STR ( FILE *in, FILE *out,
       SEGLOC_STR *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_LOC_POSTER_STR ( FILE *in, FILE *out,
       SEGLOC_LOC_POSTER_STR *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_MISC_POSTER_STR ( FILE *in, FILE *out,
       SEGLOC_MISC_POSTER_STR *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_MEPOS_POSTER_STR ( FILE *in, FILE *out,
       SEGLOC_MEPOS_POSTER_STR *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_MAP_POSTER_STR ( FILE *in, FILE *out,
       SEGLOC_MAP_POSTER_STR *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_SEGS_POSTER_STR ( FILE *in, FILE *out,
       SEGLOC_SEGS_POSTER_STR *x, int indent, int nDim, int *dims );
extern int scan_SEGLOC_ASPECT_POSTER_STR ( FILE *in, FILE *out,
       SEGLOC_ASPECT_POSTER_STR *x, int indent, int nDim, int *dims );
#ifdef __cplusplus
}
#endif

#endif /* SEGLOC_SCAN_H */

