
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

/* 
 * seglocType.h:     La SDI_F de segloc
 *
 * Utilise par le module et par les clients
 * (inclut dans seglocMsgLib.h et seglocPosterLib.h)
 * 
 */

#ifndef segloc_TYPE_H
#define segloc_TYPE_H

#include "genom/modules.h"
#include "seglocError.h"

/* Nombre de tache d'execution de ce module */
#define SEGLOC_NB_EXEC_TASK                   (1)


#endif
#ifndef segloc_TYPE1_H
#define segloc_TYPE1_H

#include "/opt/openrobots/include/pom/pomStruct.h"
#include "/opt/openrobots/include/sick/sickStruct.h"
#include "seglocStruct.h"

/*
 * Structure de donnees interne
 */
typedef struct SEGLOC_STR {
	SEGLOC_STATE state;
	SEGLOC_LOC_PARAMS locParams[4];
	SEGLOC_LOC_PARAMS locParamsRqst;
	SEGLOC_SEG_PARAMS segParams;
	SEGLOC_INIT initParams;
	SEGLOC_CLIP_MAP_PARAMS clipMapParams;
	SEGLOC_POS_VAR seglocTransf;
	SEGLOC_POS_VAR_SPEED sickLocoPos;
	SEGLOC_POS_VAR sickSeglocPos;
	SEGLOC_UNC sickLocoUncertainties;
	SEGLOC_UNC sickSeglocUncertainties;
	POM_SENSOR_POS sickPomPos;
	SEGLOC_POS_VAR_SPEED currentLocoPos;
	SEGLOC_POS_VAR currentSeglocPos;
	SEGLOC_UNCERTAIN_POS initPos;
	SEGLOC_START_END_POS changePositions;
	SEGLOC_LOC_REPORT locReport;
	int segkitBest;
	double confidenceAttributes[8];
	SEGLOC_TIMES seglocTimes;
	SEGLOC_UNC survPosUncertainties;
	SEGLOC_SURV_LOC_REPORT survLocReport;
	SEGLOC_STAT stat;
	SEGLOC_MAP_EDIT mapEdit;
	SEGLOC_OFFLINE offlineParams;
	SEGLOC_COMPASS_STR compass;
	double deltaCompassTab[100];
	int nbCompassData;
	SEGLOC_UNC SurvLocOKInput[20];
} SEGLOC_STR;


#endif

