
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef segloc_TCLSERV_CLIENT_ERROR_H
#define segloc_TCLSERV_CLIENT_ERROR_H

#include <server/seglocError.h>

/* -- MODULES ERRORS -------------------------------------------------- */

enum segloc_error {
	E_segloc_OK					  			= 0,

	/* module errors */
	E_segloc_BAD_PARAMS                     = S_segloc_BAD_PARAMS,
	E_segloc_ERROR                          = S_segloc_ERROR,
	E_segloc_SEG_NOT_FOUND                  = S_segloc_SEG_NOT_FOUND,
	E_segloc_TOO_MANY_SEGS_IN_MAP           = S_segloc_TOO_MANY_SEGS_IN_MAP,
	E_segloc_POSTER_NOT_FOUND               = S_segloc_POSTER_NOT_FOUND,
	E_segloc_SERVER_FAILED                  = S_segloc_SERVER_FAILED,
	E_segloc_FILE_NOT_FOUND                 = S_segloc_FILE_NOT_FOUND,
	E_segloc_FAILED                         = S_segloc_FAILED,
	E_segloc_SEVERAL_SOLUTIONS              = S_segloc_SEVERAL_SOLUTIONS,
	E_segloc_SEG_FAILED                     = S_segloc_SEG_FAILED,
	E_segloc_BIG_JUMP                       = S_segloc_BIG_JUMP,
	E_segloc_PARTIAL_LOC                    = S_segloc_PARTIAL_LOC,
	E_segloc_LOC_FAILED                     = S_segloc_LOC_FAILED,
	E_segloc_INIT_FAILED                    = S_segloc_INIT_FAILED,


	/* std errors */
	E_segloc_ACTIVITY_INTERRUPTED           = S_segloc_stdGenoM_ACTIVITY_INTERRUPTED,
	E_segloc_TOO_MANY_ACTIVITIES            = S_segloc_stdGenoM_TOO_MANY_ACTIVITIES,
	E_segloc_ACTIVITY_FAILED                = S_segloc_stdGenoM_ACTIVITY_FAILED,
	E_segloc_WAIT_ABORT_ZOMBIE_ACTIVITY     = S_segloc_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY,
	E_segloc_UNKNOWN_ACTIVITY               = S_segloc_stdGenoM_UNKNOWN_ACTIVITY,
	E_segloc_FORBIDDEN_ACTIVITY_TRANSITION  = S_segloc_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION,
	E_segloc_SYSTEM_ERROR                   = S_segloc_stdGenoM_SYSTEM_ERROR,
	E_segloc_ACTIVITY_ALREADY_ENDED         = S_segloc_stdGenoM_ACTIVITY_ALREADY_ENDED,
	E_segloc_WAIT_INIT_RQST                 = S_segloc_stdGenoM_WAIT_INIT_RQST,
	E_segloc_CONTROL_CODEL_ERROR            = S_segloc_stdGenoM_CONTROL_CODEL_ERROR,
	E_segloc_EXEC_TASK_SUSPENDED            = S_segloc_stdGenoM_EXEC_TASK_SUSPENDED,
	E_segloc_BAD_BLOCK_TYPE                 = S_segloc_stdGenoM_BAD_BLOCK_TYPE,
	E_segloc_BAD_POSTER_TYPE                = S_segloc_stdGenoM_BAD_POSTER_TYPE,

};

typedef enum segloc_error segloc_error_t;

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Take an error string in parameter, and try to get the error index associated
 * to this string
 * Returns -1 in failure case (and err is not set)
 * Returns 0 in success case (and err has a sensitive value)
 */
int segloc_decode_error(const char* str, int *err);

/*
 * Take an integer representing an error, and try to get its textual
 * representation, in the segloc context.
 *
 * Returns NULL in case of failure
 */
const char* segloc_error_str(int err);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
