
/* 
 * Copyright (c) 1993-2003,2024 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef SEGLOC_TCLSERVCLIENT_SCAN_H
#define SEGLOC_TCLSERVCLIENT_SCAN_H


/* Structures definies par d'autres modules */

#include "server/tclservClient/sickTclservClientDecode.h"

#include "server/tclservClient/pomTclservClientDecode.h"


/* Structures du module */
#include "server/seglocPosterLib.h"

/* Prototypes */
#ifdef __cplusplus
extern "C" {
#endif
int scan_buf_struct_SEGLOC_ASPECT_POSTER_STR (char** buf, struct SEGLOC_ASPECT_POSTER_STR *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_SEGS_POSTER_STR (char** buf, struct SEGLOC_SEGS_POSTER_STR *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_MAP_POSTER_STR (char** buf, struct SEGLOC_MAP_POSTER_STR *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_MEPOS_POSTER_STR (char** buf, struct SEGLOC_MEPOS_POSTER_STR *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_MISC_POSTER_STR (char** buf, struct SEGLOC_MISC_POSTER_STR *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_LOC_POSTER_STR (char** buf, struct SEGLOC_LOC_POSTER_STR *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_STR (char** buf, struct SEGLOC_STR *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_MAP (char** buf, struct SEGLOC_MAP *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_MAP_HEADER (char** buf, struct SEGLOC_MAP_HEADER *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_MATCHED_SEGS (char** buf, struct SEGLOC_MATCHED_SEGS *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_MATCHED_SEG (char** buf, struct SEGLOC_MATCHED_SEG *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_MATCHED_SEG_HEADER (char** buf, struct SEGLOC_MATCHED_SEG_HEADER *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_ASPECT_SEGS (char** buf, struct SEGLOC_ASPECT_SEGS *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_ACQ_SEGS (char** buf, struct SEGLOC_ACQ_SEGS *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_SEG_HEADER (char** buf, struct SEGLOC_SEG_HEADER *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_SEG_PARAMS (char** buf, struct SEGLOC_SEG_PARAMS *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_MAP_EDIT (char** buf, struct SEGLOC_MAP_EDIT *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_CUT_SEG (char** buf, struct SEGLOC_CUT_SEG *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_2SEGS (char** buf, struct SEGLOC_2SEGS *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_SEG (char** buf, struct SEGLOC_SEG *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_COMPASS_STR (char** buf, struct SEGLOC_COMPASS_STR *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_COMPASS_RES (char** buf, struct SEGLOC_COMPASS_RES *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_COMPASS_ENV (char** buf, struct SEGLOC_COMPASS_ENV *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_OFFLINE (char** buf, struct SEGLOC_OFFLINE *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_STAT (char** buf, struct SEGLOC_STAT *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_STATE (char** buf, struct SEGLOC_STATE *x, int nDim, int *dims );
int scan_buf_enum_SEGLOC_SURV_LOC_REPORT (char** buf, enum SEGLOC_SURV_LOC_REPORT *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_TIMES (char** buf, struct SEGLOC_TIMES *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_LOC_REPORT (char** buf, struct SEGLOC_LOC_REPORT *x, int nDim, int *dims );
int scan_buf_enum_SEGLOC_CONFIDENCE_ATTRIBUTES (char** buf, enum SEGLOC_CONFIDENCE_ATTRIBUTES *x, int nDim, int *dims );
int scan_buf_enum_SEGLOC_LOC_QUALITY (char** buf, enum SEGLOC_LOC_QUALITY *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_LOC_PARAMS (char** buf, struct SEGLOC_LOC_PARAMS *x, int nDim, int *dims );
int scan_buf_enum_SEGLOC_UPDATE_LOCO (char** buf, enum SEGLOC_UPDATE_LOCO *x, int nDim, int *dims );
int scan_buf_enum_SEGLOC_LOC_MODE (char** buf, enum SEGLOC_LOC_MODE *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_START_END_POS (char** buf, struct SEGLOC_START_END_POS *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_UNCERTAIN_POS (char** buf, struct SEGLOC_UNCERTAIN_POS *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_POS_VAR_SPEED (char** buf, struct SEGLOC_POS_VAR_SPEED *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_POS_VAR (char** buf, struct SEGLOC_POS_VAR *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_VARIANCES (char** buf, struct SEGLOC_VARIANCES *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_POS_SPEED (char** buf, struct SEGLOC_POS_SPEED *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_SPEED (char** buf, struct SEGLOC_SPEED *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_UNC (char** buf, struct SEGLOC_UNC *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_POS (char** buf, struct SEGLOC_POS *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_CLIP_MAP_PARAMS (char** buf, struct SEGLOC_CLIP_MAP_PARAMS *x, int nDim, int *dims );
int scan_buf_enum_SEGLOC_CLIP_MODE (char** buf, enum SEGLOC_CLIP_MODE *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_INIT (char** buf, struct SEGLOC_INIT *x, int nDim, int *dims );
int scan_buf_struct_SEGLOC_FILE_PARAMS (char** buf, struct SEGLOC_FILE_PARAMS *x, int nDim, int *dims );
int scan_buf_enum_SEGLOC_BOOL (char** buf, enum SEGLOC_BOOL *x, int nDim, int *dims );

/* ======================== SCAN DES TYPEDEF ============================= */

int scan_buf_SEGLOC_BOOL (char** buf, SEGLOC_BOOL *x, int nDim, int *dims );
int scan_buf_SEGLOC_FILE_PARAMS (char** buf, SEGLOC_FILE_PARAMS *x, int nDim, int *dims );
int scan_buf_SEGLOC_INIT (char** buf, SEGLOC_INIT *x, int nDim, int *dims );
int scan_buf_SEGLOC_CLIP_MODE (char** buf, SEGLOC_CLIP_MODE *x, int nDim, int *dims );
int scan_buf_SEGLOC_CLIP_MAP_PARAMS (char** buf, SEGLOC_CLIP_MAP_PARAMS *x, int nDim, int *dims );
int scan_buf_SEGLOC_POS (char** buf, SEGLOC_POS *x, int nDim, int *dims );
int scan_buf_SEGLOC_UNC (char** buf, SEGLOC_UNC *x, int nDim, int *dims );
int scan_buf_SEGLOC_SPEED (char** buf, SEGLOC_SPEED *x, int nDim, int *dims );
int scan_buf_SEGLOC_POS_SPEED (char** buf, SEGLOC_POS_SPEED *x, int nDim, int *dims );
int scan_buf_SEGLOC_VARIANCES (char** buf, SEGLOC_VARIANCES *x, int nDim, int *dims );
int scan_buf_SEGLOC_POS_VAR (char** buf, SEGLOC_POS_VAR *x, int nDim, int *dims );
int scan_buf_SEGLOC_POS_VAR_SPEED (char** buf, SEGLOC_POS_VAR_SPEED *x, int nDim, int *dims );
int scan_buf_SEGLOC_UNCERTAIN_POS (char** buf, SEGLOC_UNCERTAIN_POS *x, int nDim, int *dims );
int scan_buf_SEGLOC_START_END_POS (char** buf, SEGLOC_START_END_POS *x, int nDim, int *dims );
int scan_buf_SEGLOC_LOC_MODE (char** buf, SEGLOC_LOC_MODE *x, int nDim, int *dims );
int scan_buf_SEGLOC_UPDATE_LOCO (char** buf, SEGLOC_UPDATE_LOCO *x, int nDim, int *dims );
int scan_buf_SEGLOC_LOC_PARAMS (char** buf, SEGLOC_LOC_PARAMS *x, int nDim, int *dims );
int scan_buf_SEGLOC_LOC_QUALITY (char** buf, SEGLOC_LOC_QUALITY *x, int nDim, int *dims );
int scan_buf_SEGLOC_CONFIDENCE_ATTRIBUTES (char** buf, SEGLOC_CONFIDENCE_ATTRIBUTES *x, int nDim, int *dims );
int scan_buf_SEGLOC_LOC_REPORT (char** buf, SEGLOC_LOC_REPORT *x, int nDim, int *dims );
int scan_buf_SEGLOC_TIMES (char** buf, SEGLOC_TIMES *x, int nDim, int *dims );
int scan_buf_SEGLOC_SURV_LOC_REPORT (char** buf, SEGLOC_SURV_LOC_REPORT *x, int nDim, int *dims );
int scan_buf_SEGLOC_STATE (char** buf, SEGLOC_STATE *x, int nDim, int *dims );
int scan_buf_SEGLOC_STAT (char** buf, SEGLOC_STAT *x, int nDim, int *dims );
int scan_buf_SEGLOC_OFFLINE (char** buf, SEGLOC_OFFLINE *x, int nDim, int *dims );
int scan_buf_SEGLOC_COMPASS_ENV (char** buf, SEGLOC_COMPASS_ENV *x, int nDim, int *dims );
int scan_buf_SEGLOC_COMPASS_RES (char** buf, SEGLOC_COMPASS_RES *x, int nDim, int *dims );
int scan_buf_SEGLOC_COMPASS_STR (char** buf, SEGLOC_COMPASS_STR *x, int nDim, int *dims );
int scan_buf_SEGLOC_SEG (char** buf, SEGLOC_SEG *x, int nDim, int *dims );
int scan_buf_SEGLOC_2SEGS (char** buf, SEGLOC_2SEGS *x, int nDim, int *dims );
int scan_buf_SEGLOC_CUT_SEG (char** buf, SEGLOC_CUT_SEG *x, int nDim, int *dims );
int scan_buf_SEGLOC_MAP_EDIT (char** buf, SEGLOC_MAP_EDIT *x, int nDim, int *dims );
int scan_buf_SEGLOC_SEG_PARAMS (char** buf, SEGLOC_SEG_PARAMS *x, int nDim, int *dims );
int scan_buf_SEGLOC_SEG_HEADER (char** buf, SEGLOC_SEG_HEADER *x, int nDim, int *dims );
int scan_buf_SEGLOC_ACQ_SEGS (char** buf, SEGLOC_ACQ_SEGS *x, int nDim, int *dims );
int scan_buf_SEGLOC_ASPECT_SEGS (char** buf, SEGLOC_ASPECT_SEGS *x, int nDim, int *dims );
int scan_buf_SEGLOC_MATCHED_SEG_HEADER (char** buf, SEGLOC_MATCHED_SEG_HEADER *x, int nDim, int *dims );
int scan_buf_SEGLOC_MATCHED_SEG (char** buf, SEGLOC_MATCHED_SEG *x, int nDim, int *dims );
int scan_buf_SEGLOC_MATCHED_SEGS (char** buf, SEGLOC_MATCHED_SEGS *x, int nDim, int *dims );
int scan_buf_SEGLOC_MAP_HEADER (char** buf, SEGLOC_MAP_HEADER *x, int nDim, int *dims );
int scan_buf_SEGLOC_MAP (char** buf, SEGLOC_MAP *x, int nDim, int *dims );
int scan_buf_SEGLOC_STR (char** buf, SEGLOC_STR *x, int nDim, int *dims );
int scan_buf_SEGLOC_LOC_POSTER_STR (char** buf, SEGLOC_LOC_POSTER_STR *x, int nDim, int *dims );
int scan_buf_SEGLOC_MISC_POSTER_STR (char** buf, SEGLOC_MISC_POSTER_STR *x, int nDim, int *dims );
int scan_buf_SEGLOC_MEPOS_POSTER_STR (char** buf, SEGLOC_MEPOS_POSTER_STR *x, int nDim, int *dims );
int scan_buf_SEGLOC_MAP_POSTER_STR (char** buf, SEGLOC_MAP_POSTER_STR *x, int nDim, int *dims );
int scan_buf_SEGLOC_SEGS_POSTER_STR (char** buf, SEGLOC_SEGS_POSTER_STR *x, int nDim, int *dims );
int scan_buf_SEGLOC_ASPECT_POSTER_STR (char** buf, SEGLOC_ASPECT_POSTER_STR *x, int nDim, int *dims );
#ifdef __cplusplus
}
#endif

#endif /* SEGLOC_SCAN_H */

