
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef segloc_TCLSERV_CLIENT_MSG_LIB_H
#define segloc_TCLSERV_CLIENT_MSG_LIB_H

#include <server/seglocType.h>

/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif

int seglocTclservClientInit (TCLSERV_CLIENT_ID pClientId);

int seglocTclservClientEnd (TCLSERV_CLIENT_ID clientId);



int seglocTclservClientInitRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 SEGLOC_INIT *(in_initParams) 
		);

int seglocTclservClientInitReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int seglocTclservClientInitRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				SEGLOC_INIT *(in_initParams) ,
				
				int *bilan);

int seglocTclservClientInitRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					SEGLOC_INIT *(in_initParams) ,
					
					int *bilan);




int seglocTclservClientGetInitRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int seglocTclservClientGetInitReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       SEGLOC_INIT *(out_initParams),
			       int *bilan);

int seglocTclservClientGetInitRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 SEGLOC_INIT *(out_initParams),
				 int *bilan);




int seglocTclservClientSegmentationOnRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int seglocTclservClientSegmentationOnReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int seglocTclservClientSegmentationOnRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int seglocTclservClientSegmentationOffRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int seglocTclservClientSegmentationOffReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int seglocTclservClientSegmentationOffRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int seglocTclservClientGetSegmentationParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int seglocTclservClientGetSegmentationParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       SEGLOC_SEG_PARAMS *(out_segParams),
			       int *bilan);

int seglocTclservClientGetSegmentationParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 SEGLOC_SEG_PARAMS *(out_segParams),
				 int *bilan);




int seglocTclservClientSetSegmentationParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 SEGLOC_SEG_PARAMS *(in_segParams)
		);

int seglocTclservClientSetSegmentationParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int seglocTclservClientSetSegmentationParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 SEGLOC_SEG_PARAMS *(in_segParams) ,
				 
				 int *bilan);




int seglocTclservClientLocLocalRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 SEGLOC_UNCERTAIN_POS *(in_initPos) 
		);

int seglocTclservClientLocLocalReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      SEGLOC_POS *(out_pos),
			      int *bilan);


int seglocTclservClientLocLocalRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				SEGLOC_UNCERTAIN_POS *(in_initPos) ,
				SEGLOC_POS *(out_pos),
				int *bilan);

int seglocTclservClientLocLocalRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					SEGLOC_UNCERTAIN_POS *(in_initPos) ,
					SEGLOC_POS *(out_pos),
					int *bilan);




int seglocTclservClientForceLocLocalRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 SEGLOC_UNCERTAIN_POS *(in_initPos) 
		);

int seglocTclservClientForceLocLocalReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      SEGLOC_POS *(out_pos),
			      int *bilan);


int seglocTclservClientForceLocLocalRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				SEGLOC_UNCERTAIN_POS *(in_initPos) ,
				SEGLOC_POS *(out_pos),
				int *bilan);

int seglocTclservClientForceLocLocalRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					SEGLOC_UNCERTAIN_POS *(in_initPos) ,
					SEGLOC_POS *(out_pos),
					int *bilan);




int seglocTclservClientReLocRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int seglocTclservClientReLocReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      SEGLOC_POS *(out_pos),
			      int *bilan);


int seglocTclservClientReLocRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				SEGLOC_POS *(out_pos),
				int *bilan);

int seglocTclservClientReLocRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					SEGLOC_POS *(out_pos),
					int *bilan);




int seglocTclservClientLocOnceRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int seglocTclservClientLocOnceReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      SEGLOC_POS *(out_pos),
			      int *bilan);


int seglocTclservClientLocOnceRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				SEGLOC_POS *(out_pos),
				int *bilan);

int seglocTclservClientLocOnceRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					SEGLOC_POS *(out_pos),
					int *bilan);




int seglocTclservClientLocLoopRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int seglocTclservClientLocLoopReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int seglocTclservClientLocLoopRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int seglocTclservClientLocLoopRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int seglocTclservClientLocDynamicMapLoopRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int seglocTclservClientLocDynamicMapLoopReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int seglocTclservClientLocDynamicMapLoopRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int seglocTclservClientLocDynamicMapLoopRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int seglocTclservClientGetLocParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 SEGLOC_LOC_MODE *(in_locMode)
		);

int seglocTclservClientGetLocParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       SEGLOC_LOC_PARAMS *(out_locParamsRqst),
			       int *bilan);

int seglocTclservClientGetLocParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 SEGLOC_LOC_MODE *(in_locMode) ,
				 SEGLOC_LOC_PARAMS *(out_locParamsRqst),
				 int *bilan);




int seglocTclservClientSetLocParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 SEGLOC_LOC_PARAMS *(in_locParamsRqst)
		);

int seglocTclservClientSetLocParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int seglocTclservClientSetLocParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 SEGLOC_LOC_PARAMS *(in_locParamsRqst) ,
				 
				 int *bilan);




int seglocTclservClientSurvLocKORqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 SEGLOC_UNC *(in_survPosUncertainties) 
		);

int seglocTclservClientSurvLocKOReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      SEGLOC_SURV_LOC_REPORT *(out_survLocReport),
			      int *bilan);


int seglocTclservClientSurvLocKORqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				SEGLOC_UNC *(in_survPosUncertainties) ,
				SEGLOC_SURV_LOC_REPORT *(out_survLocReport),
				int *bilan);

int seglocTclservClientSurvLocKORqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					SEGLOC_UNC *(in_survPosUncertainties) ,
					SEGLOC_SURV_LOC_REPORT *(out_survLocReport),
					int *bilan);




int seglocTclservClientSurvLocOKRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 SEGLOC_UNC *(in_survPosUncertainties) 
		);

int seglocTclservClientSurvLocOKReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int seglocTclservClientSurvLocOKRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				SEGLOC_UNC *(in_survPosUncertainties) ,
				
				int *bilan);

int seglocTclservClientSurvLocOKRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					SEGLOC_UNC *(in_survPosUncertainties) ,
					
					int *bilan);




int seglocTclservClientStopRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int seglocTclservClientStopReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int seglocTclservClientStopRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int seglocTclservClientResetMainToBaseFromRflexRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int seglocTclservClientResetMainToBaseFromRflexReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int seglocTclservClientResetMainToBaseFromRflexRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int seglocTclservClientResetMainToBaseFromRflexRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int seglocTclservClientLoadMapRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 SEGLOC_FILE_PARAMS *(in_mapFile) 
		);

int seglocTclservClientLoadMapReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int seglocTclservClientLoadMapRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				SEGLOC_FILE_PARAMS *(in_mapFile) ,
				
				int *bilan);

int seglocTclservClientLoadMapRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					SEGLOC_FILE_PARAMS *(in_mapFile) ,
					
					int *bilan);




int seglocTclservClientGetMapFileRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int seglocTclservClientGetMapFileReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       SEGLOC_FILE_PARAMS *(out_mapFile),
			       int *bilan);

int seglocTclservClientGetMapFileRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 SEGLOC_FILE_PARAMS *(out_mapFile),
				 int *bilan);




int seglocTclservClientSaveMapRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 SEGLOC_FILE_PARAMS *(in_mapFile) 
		);

int seglocTclservClientSaveMapReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int seglocTclservClientSaveMapRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				SEGLOC_FILE_PARAMS *(in_mapFile) ,
				
				int *bilan);

int seglocTclservClientSaveMapRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					SEGLOC_FILE_PARAMS *(in_mapFile) ,
					
					int *bilan);




int seglocTclservClientClipMapRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 SEGLOC_CLIP_MAP_PARAMS *(in_clipMapParams) 
		);

int seglocTclservClientClipMapReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int seglocTclservClientClipMapRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				SEGLOC_CLIP_MAP_PARAMS *(in_clipMapParams) ,
				
				int *bilan);

int seglocTclservClientClipMapRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					SEGLOC_CLIP_MAP_PARAMS *(in_clipMapParams) ,
					
					int *bilan);




int seglocTclservClientAddSegsInMapRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int seglocTclservClientAddSegsInMapReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int seglocTclservClientAddSegsInMapRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int seglocTclservClientAddSegsInMapRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int seglocTclservClientResetFrameRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 SEGLOC_START_END_POS *(in_changePositions) 
		);

int seglocTclservClientResetFrameReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int seglocTclservClientResetFrameRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				SEGLOC_START_END_POS *(in_changePositions) ,
				
				int *bilan);

int seglocTclservClientResetFrameRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					SEGLOC_START_END_POS *(in_changePositions) ,
					
					int *bilan);




int seglocTclservClientSetNorthEnvRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 SEGLOC_COMPASS_ENV *(in_compassEnv)
		);

int seglocTclservClientSetNorthEnvReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       SEGLOC_COMPASS_RES *(out_compassRes),
			       int *bilan);

int seglocTclservClientSetNorthEnvRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 SEGLOC_COMPASS_ENV *(in_compassEnv) ,
				 SEGLOC_COMPASS_RES *(out_compassRes),
				 int *bilan);




int seglocTclservClientRemoveSegmentRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 SEGLOC_SEG *(in_seg1) 
		);

int seglocTclservClientRemoveSegmentReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int seglocTclservClientRemoveSegmentRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				SEGLOC_SEG *(in_seg1) ,
				
				int *bilan);

int seglocTclservClientRemoveSegmentRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					SEGLOC_SEG *(in_seg1) ,
					
					int *bilan);




int seglocTclservClientMergeSegmentsRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 SEGLOC_2SEGS *(in_segs) 
		);

int seglocTclservClientMergeSegmentsReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int seglocTclservClientMergeSegmentsRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				SEGLOC_2SEGS *(in_segs) ,
				
				int *bilan);

int seglocTclservClientMergeSegmentsRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					SEGLOC_2SEGS *(in_segs) ,
					
					int *bilan);




int seglocTclservClientIntersectSegmentsRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 SEGLOC_2SEGS *(in_segs) 
		);

int seglocTclservClientIntersectSegmentsReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int seglocTclservClientIntersectSegmentsRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				SEGLOC_2SEGS *(in_segs) ,
				
				int *bilan);

int seglocTclservClientIntersectSegmentsRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					SEGLOC_2SEGS *(in_segs) ,
					
					int *bilan);




int seglocTclservClientCutSegmentRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 SEGLOC_CUT_SEG *(in_segCut) 
		);

int seglocTclservClientCutSegmentReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int seglocTclservClientCutSegmentRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				SEGLOC_CUT_SEG *(in_segCut) ,
				
				int *bilan);

int seglocTclservClientCutSegmentRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					SEGLOC_CUT_SEG *(in_segCut) ,
					
					int *bilan);




int seglocTclservClientSetOfflineModeRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 SEGLOC_OFFLINE *(in_offlineParams) 
		);

int seglocTclservClientSetOfflineModeReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int seglocTclservClientSetOfflineModeRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				SEGLOC_OFFLINE *(in_offlineParams) ,
				
				int *bilan);

int seglocTclservClientSetOfflineModeRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					SEGLOC_OFFLINE *(in_offlineParams) ,
					
					int *bilan);




int seglocTclservClientGetOfflineModeParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int seglocTclservClientGetOfflineModeParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       SEGLOC_OFFLINE *(out_offlineParams),
			       int *bilan);

int seglocTclservClientGetOfflineModeParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 SEGLOC_OFFLINE *(out_offlineParams),
				 int *bilan);


#ifdef __cplusplus
}
#endif
#endif /* seglocTCLSERV_CLIENT_MSG_LIB_H */

