
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] seglocInstall] >= 0 } {
    interp expose {} seglocInstall
}

proc ::seglocInstall { name } {
    foreach rqst { "Init" "GetInit" "SegmentationOn" "SegmentationOff" "GetSegmentationParams" "SetSegmentationParams" "LocLocal" "ForceLocLocal" "ReLoc" "LocOnce" "LocLoop" "LocDynamicMapLoop" "GetLocParams" "SetLocParams" "SurvLocKO" "SurvLocOK" "Stop" "ResetMainToBaseFromRflex" "LoadMap" "GetMapFile" "SaveMap" "ClipMap" "AddSegsInMap" "ResetFrame" "SetNorthEnv" "RemoveSegment" "MergeSegments" "IntersectSegments" "CutSegment" "SetOfflineMode" "GetOfflineModeParams" "LocTransfPosterRead" "LocReportPosterRead" "MiscSickLocoPosPosterRead" "MiscSickSeglocPosPosterRead" "MiscCurrentLocoPosPosterRead" "MiscCurrentSeglocPosPosterRead" "MiscseglocTimesPosterRead" "MiscSickLocoUncertaintiesPosterRead" "MiscSickSeglocUncertaintiesPosterRead" "MiscStatPosterRead" "MiscCompassPosterRead" "MEPosPosPosterRead" "MapMapPosterRead" "SegsSegsPosterRead" "AspectAspectPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} segloc$rqst $name
    }
}

interp hide {} seglocInstall




# Init ----------------------------------------------------------

if { [lsearch [interp hidden] seglocInit] >= 0 } {
    interp expose {} seglocInit
}
if { [lsearch [interp hidden] seglocInitFormatOutput] >= 0 } {
    interp expose {} seglocInitFormatOutput
}

proc ::seglocInit { name args } {
    set format {}
    lappend format [list string "A file with a map with segkit format" "/usr/local/openrobots/data/environments/laas-gs/maps/gs.map" ]
    lappend format [list int "File extension number (or -1)" -1 ]
    lappend format [list int "unused" 0 ]
    lappend format [list string "Poster where to get the current robot position" 0 ]
    lappend format [list string "Poster where to get the laser data" 0 ]

    return [ ::cs::rqstSend "${name}" "Init" \
	"Segloc needs a map file, in segloc format (<file>.map), a poster to read the current pos (unless in offline mode using request SetOfflineMode), and a poster to read the laser data." \
	"SEGLOC_INIT\n| SEGLOC_FILE_PARAMS\n| | char baseName\[256\]\n| | int num\n| | int unused\n| char posPosterName\[64\]\n| char laserDataPosterName\[64\]\n" \
	5 \
	$format \
	$args ]
}


proc ::seglocInitFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocInit
interp hide {} seglocInitFormatOutput





# GetInit ----------------------------------------------------------

if { [lsearch [interp hidden] seglocGetInit] >= 0 } {
    interp expose {} seglocGetInit
}
if { [lsearch [interp hidden] seglocGetInitFormatOutput] >= 0 } {
    interp expose {} seglocGetInitFormatOutput
}

proc ::seglocGetInit { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetInit" \
	"<some doc>" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::seglocGetInitFormatOutput { list } {
    set format { {} status { } { initParams { } { mapFile { } baseName { } num { } unused } { } posPosterName { } laserDataPosterName } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocGetInit
interp hide {} seglocGetInitFormatOutput





# SegmentationOn ----------------------------------------------------------

if { [lsearch [interp hidden] seglocSegmentationOn] >= 0 } {
    interp expose {} seglocSegmentationOn
}
if { [lsearch [interp hidden] seglocSegmentationOnFormatOutput] >= 0 } {
    interp expose {} seglocSegmentationOnFormatOutput
}

proc ::seglocSegmentationOn { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "SegmentationOn" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::seglocSegmentationOnFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocSegmentationOn
interp hide {} seglocSegmentationOnFormatOutput





# SegmentationOff ----------------------------------------------------------

if { [lsearch [interp hidden] seglocSegmentationOff] >= 0 } {
    interp expose {} seglocSegmentationOff
}
if { [lsearch [interp hidden] seglocSegmentationOffFormatOutput] >= 0 } {
    interp expose {} seglocSegmentationOffFormatOutput
}

proc ::seglocSegmentationOff { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "SegmentationOff" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::seglocSegmentationOffFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocSegmentationOff
interp hide {} seglocSegmentationOffFormatOutput





# GetSegmentationParams ----------------------------------------------------------

if { [lsearch [interp hidden] seglocGetSegmentationParams] >= 0 } {
    interp expose {} seglocGetSegmentationParams
}
if { [lsearch [interp hidden] seglocGetSegmentationParamsFormatOutput] >= 0 } {
    interp expose {} seglocGetSegmentationParamsFormatOutput
}

proc ::seglocGetSegmentationParams { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetSegmentationParams" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::seglocGetSegmentationParamsFormatOutput { list } {
    set format { {} status { } { segParams { } getVariances { } nbMinSegPts { } leastSquareThres { } distMaxSegPts } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocGetSegmentationParams
interp hide {} seglocGetSegmentationParamsFormatOutput





# SetSegmentationParams ----------------------------------------------------------

if { [lsearch [interp hidden] seglocSetSegmentationParams] >= 0 } {
    interp expose {} seglocSetSegmentationParams
}
if { [lsearch [interp hidden] seglocSetSegmentationParamsFormatOutput] >= 0 } {
    interp expose {} seglocSetSegmentationParamsFormatOutput
}

proc ::seglocSetSegmentationParams { name args } {
    set format {}
    lappend format [list { "SEGLOC_TRUE" "SEGLOC_FALSE" } "segParams.getVariances" "" ]
    lappend format [list int "segParams.nbMinSegPts" 0 ]
    lappend format [list double "segParams.leastSquareThres" 0.0 ]
    lappend format [list double "segParams.distMaxSegPts" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetSegmentationParams" \
	"** undocumented **" \
	"SEGLOC_SEG_PARAMS\n| SEGLOC_BOOL getVariances\n| int nbMinSegPts\n| double leastSquareThres\n| double distMaxSegPts\n" \
	4 \
	$format \
	$args ]
}


proc ::seglocSetSegmentationParamsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocSetSegmentationParams
interp hide {} seglocSetSegmentationParamsFormatOutput





# LocLocal ----------------------------------------------------------

if { [lsearch [interp hidden] seglocLocLocal] >= 0 } {
    interp expose {} seglocLocLocal
}
if { [lsearch [interp hidden] seglocLocLocalFormatOutput] >= 0 } {
    interp expose {} seglocLocLocalFormatOutput
}

proc ::seglocLocLocal { name args } {
    set format {}
    lappend format [list double "initPos.pos.x" 0.0 ]
    lappend format [list double "initPos.pos.y" 0.0 ]
    lappend format [list double "initPos.pos.theta" 0.0 ]
    lappend format [list double "initPos.unc.ux" 0.0 ]
    lappend format [list double "initPos.unc.uy" 0.0 ]
    lappend format [list double "initPos.unc.utheta" 0.0 ]

    return [ ::cs::rqstSend "${name}" "LocLocal" \
	"Localization from an estimated position. Mandatory to initialize the localization. The estimated position is used to compute an 'aspect' map: it does not need to be precise but the view point must be similar to the real one to select an adapted subset of map segments" \
	"SEGLOC_UNCERTAIN_POS\n| SEGLOC_POS\n| | double x\n| | double y\n| | double theta\n| SEGLOC_UNC\n| | double ux\n| | double uy\n| | double utheta\n" \
	6 \
	$format \
	$args ]
}


proc ::seglocLocLocalFormatOutput { list } {
    set format { {} status { } { pos { } x { } y { } theta } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocLocLocal
interp hide {} seglocLocLocalFormatOutput





# ForceLocLocal ----------------------------------------------------------

if { [lsearch [interp hidden] seglocForceLocLocal] >= 0 } {
    interp expose {} seglocForceLocLocal
}
if { [lsearch [interp hidden] seglocForceLocLocalFormatOutput] >= 0 } {
    interp expose {} seglocForceLocLocalFormatOutput
}

proc ::seglocForceLocLocal { name args } {
    set format {}
    lappend format [list double "initPos.pos.x" 0.0 ]
    lappend format [list double "initPos.pos.y" 0.0 ]
    lappend format [list double "initPos.pos.theta" 0.0 ]
    lappend format [list double "initPos.unc.ux" 0.0 ]
    lappend format [list double "initPos.unc.uy" 0.0 ]
    lappend format [list double "initPos.unc.utheta" 0.0 ]

    return [ ::cs::rqstSend "${name}" "ForceLocLocal" \
	"Similar to LocLocal, but first reset the current position with the one given in parameter." \
	"SEGLOC_UNCERTAIN_POS\n| SEGLOC_POS\n| | double x\n| | double y\n| | double theta\n| SEGLOC_UNC\n| | double ux\n| | double uy\n| | double utheta\n" \
	6 \
	$format \
	$args ]
}


proc ::seglocForceLocLocalFormatOutput { list } {
    set format { {} status { } { pos { } x { } y { } theta } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocForceLocLocal
interp hide {} seglocForceLocLocalFormatOutput





# ReLoc ----------------------------------------------------------

if { [lsearch [interp hidden] seglocReLoc] >= 0 } {
    interp expose {} seglocReLoc
}
if { [lsearch [interp hidden] seglocReLocFormatOutput] >= 0 } {
    interp expose {} seglocReLocFormatOutput
}

proc ::seglocReLoc { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "ReLoc" \
	"Similar to LocLocal but segloc computes itselfthe new estimated position from the odometry.Very usefull when LocLoop cannot find out solution." \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::seglocReLocFormatOutput { list } {
    set format { {} status { } { pos { } x { } y { } theta } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocReLoc
interp hide {} seglocReLocFormatOutput





# LocOnce ----------------------------------------------------------

if { [lsearch [interp hidden] seglocLocOnce] >= 0 } {
    interp expose {} seglocLocOnce
}
if { [lsearch [interp hidden] seglocLocOnceFormatOutput] >= 0 } {
    interp expose {} seglocLocOnceFormatOutput
}

proc ::seglocLocOnce { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "LocOnce" \
	"One step of LocLoop loop. Mainly to debug LocLoop.Similar to ReLoc but takes into account the positionuncertainties." \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::seglocLocOnceFormatOutput { list } {
    set format { {} status { } { pos { } x { } y { } theta } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocLocOnce
interp hide {} seglocLocOnceFormatOutput





# LocLoop ----------------------------------------------------------

if { [lsearch [interp hidden] seglocLocLoop] >= 0 } {
    interp expose {} seglocLocLoop
}
if { [lsearch [interp hidden] seglocLocLoopFormatOutput] >= 0 } {
    interp expose {} seglocLocLoopFormatOutput
}

proc ::seglocLocLoop { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "LocLoop" \
	"Main localization procedure. Tracking mode.First call LocLocal to initialize the loc" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::seglocLocLoopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocLocLoop
interp hide {} seglocLocLoopFormatOutput





# LocDynamicMapLoop ----------------------------------------------------------

if { [lsearch [interp hidden] seglocLocDynamicMapLoop] >= 0 } {
    interp expose {} seglocLocDynamicMapLoop
}
if { [lsearch [interp hidden] seglocLocDynamicMapLoopFormatOutput] >= 0 } {
    interp expose {} seglocLocDynamicMapLoopFormatOutput
}

proc ::seglocLocDynamicMapLoop { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "LocDynamicMapLoop" \
	"Like locLoop but with dynamic map building. Segs behind are removed." \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::seglocLocDynamicMapLoopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocLocDynamicMapLoop
interp hide {} seglocLocDynamicMapLoopFormatOutput





# GetLocParams ----------------------------------------------------------

if { [lsearch [interp hidden] seglocGetLocParams] >= 0 } {
    interp expose {} seglocGetLocParams
}
if { [lsearch [interp hidden] seglocGetLocParamsFormatOutput] >= 0 } {
    interp expose {} seglocGetLocParamsFormatOutput
}

proc ::seglocGetLocParams { name args } {
    set format {}
    lappend format [list { "SEGLOC_LOC_LOOP" "SEGLOC_LOC_ONCE" "SEGLOC_FORCE_LOC_LOCAL" "SEGLOC_LOC_LOCAL" } "locMode" "" ]

    return [ ::cs::rqstSend "${name}" "GetLocParams" \
	"Localization parametres for each loc mode." \
	"SEGLOC_LOC_MODE locMode\n" \
	1 \
	$format \
	$args ]
}


proc ::seglocGetLocParamsFormatOutput { list } {
    set format { {} status { } { locParamsRqst { } locMode { } nbMaxFailures { } variancesFilter { } visibilityFilter { } useCompass { } updatePosMode { } posDistMahaThres { } mapDistMahaThres { } angleUncertainty { } factUncertaintyTest { } segkitSimulErr { } corridorModeAllowed { } simulErrLin { } simulErrAng { } simulErrLinAng } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocGetLocParams
interp hide {} seglocGetLocParamsFormatOutput





# SetLocParams ----------------------------------------------------------

if { [lsearch [interp hidden] seglocSetLocParams] >= 0 } {
    interp expose {} seglocSetLocParams
}
if { [lsearch [interp hidden] seglocSetLocParamsFormatOutput] >= 0 } {
    interp expose {} seglocSetLocParamsFormatOutput
}

proc ::seglocSetLocParams { name args } {
    set format {}
    lappend format [list { "SEGLOC_LOC_LOOP" "SEGLOC_LOC_ONCE" "SEGLOC_FORCE_LOC_LOCAL" "SEGLOC_LOC_LOCAL" } "locParamsRqst.locMode" "" ]
    lappend format [list int "locParamsRqst.nbMaxFailures" 0 ]
    lappend format [list { "SEGLOC_TRUE" "SEGLOC_FALSE" } "locParamsRqst.variancesFilter" "" ]
    lappend format [list { "SEGLOC_TRUE" "SEGLOC_FALSE" } "locParamsRqst.visibilityFilter" "" ]
    lappend format [list { "SEGLOC_TRUE" "SEGLOC_FALSE" } "locParamsRqst.useCompass" "" ]
    lappend format [list { "SEGLOC_UPDATE_POS" "SEGLOC_UPDATE_VAR" "SEGLOC_RESET_VAR" "SEGLOC_NO_UPDATE" } "locParamsRqst.updatePosMode" "" ]
    lappend format [list int "locParamsRqst.posDistMahaThres" 0 ]
    lappend format [list int "locParamsRqst.mapDistMahaThres" 0 ]
    lappend format [list double "locParamsRqst.angleUncertainty" 0.0 ]
    lappend format [list double "locParamsRqst.factUncertaintyTest" 0.0 ]
    lappend format [list { "SEGLOC_TRUE" "SEGLOC_FALSE" } "locParamsRqst.segkitSimulErr" "" ]
    lappend format [list { "SEGLOC_TRUE" "SEGLOC_FALSE" } "locParamsRqst.corridorModeAllowed" "" ]
    lappend format [list double "locParamsRqst.simulErrLin" 0.0 ]
    lappend format [list double "locParamsRqst.simulErrAng" 0.0 ]
    lappend format [list double "locParamsRqst.simulErrLinAng" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetLocParams" \
	"Localization parametres for each loc mode." \
	"SEGLOC_LOC_PARAMS\n| SEGLOC_LOC_MODE locMode\n| int nbMaxFailures\n| SEGLOC_BOOL variancesFilter\n| SEGLOC_BOOL visibilityFilter\n| SEGLOC_BOOL useCompass\n| SEGLOC_UPDATE_LOCO updatePosMode\n| long int posDistMahaThres\n| long int mapDistMahaThres\n| double angleUncertainty\n| double factUncertaintyTest\n| SEGLOC_BOOL segkitSimulErr\n| SEGLOC_BOOL corridorModeAllowed\n| double simulErrLin\n| double simulErrAng\n| double simulErrLinAng\n" \
	15 \
	$format \
	$args ]
}


proc ::seglocSetLocParamsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocSetLocParams
interp hide {} seglocSetLocParamsFormatOutput





# SurvLocKO ----------------------------------------------------------

if { [lsearch [interp hidden] seglocSurvLocKO] >= 0 } {
    interp expose {} seglocSurvLocKO
}
if { [lsearch [interp hidden] seglocSurvLocKOFormatOutput] >= 0 } {
    interp expose {} seglocSurvLocKOFormatOutput
}

proc ::seglocSurvLocKO { name args } {
    set format {}
    lappend format [list double "survPosUncertainties.ux" 0.0 ]
    lappend format [list double "survPosUncertainties.uy" 0.0 ]
    lappend format [list double "survPosUncertainties.utheta" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SurvLocKO" \
	"Monitors the loc quality: ends if the pos uncertainties are above the given threshold" \
	"SEGLOC_UNC\n| double ux\n| double uy\n| double utheta\n" \
	3 \
	$format \
	$args ]
}


proc ::seglocSurvLocKOFormatOutput { list } {
    set format { {} status { } survLocReport }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocSurvLocKO
interp hide {} seglocSurvLocKOFormatOutput





# SurvLocOK ----------------------------------------------------------

if { [lsearch [interp hidden] seglocSurvLocOK] >= 0 } {
    interp expose {} seglocSurvLocOK
}
if { [lsearch [interp hidden] seglocSurvLocOKFormatOutput] >= 0 } {
    interp expose {} seglocSurvLocOKFormatOutput
}

proc ::seglocSurvLocOK { name args } {
    set format {}
    lappend format [list double "survPosUncertainties.ux" 0.0 ]
    lappend format [list double "survPosUncertainties.uy" 0.0 ]
    lappend format [list double "survPosUncertainties.utheta" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SurvLocOK" \
	"Monitors the loc quality: ends if the 3 2D position uncertainties get back below the given threshold" \
	"SEGLOC_UNC\n| double ux\n| double uy\n| double utheta\n" \
	3 \
	$format \
	$args ]
}


proc ::seglocSurvLocOKFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocSurvLocOK
interp hide {} seglocSurvLocOKFormatOutput





# Stop ----------------------------------------------------------

if { [lsearch [interp hidden] seglocStop] >= 0 } {
    interp expose {} seglocStop
}
if { [lsearch [interp hidden] seglocStopFormatOutput] >= 0 } {
    interp expose {} seglocStopFormatOutput
}

proc ::seglocStop { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Stop" \
	"Stops all activities (LocLoop, Monitors)" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::seglocStopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocStop
interp hide {} seglocStopFormatOutput





# ResetMainToBaseFromRflex ----------------------------------------------------------

if { [lsearch [interp hidden] seglocResetMainToBaseFromRflex] >= 0 } {
    interp expose {} seglocResetMainToBaseFromRflex
}
if { [lsearch [interp hidden] seglocResetMainToBaseFromRflexFormatOutput] >= 0 } {
    interp expose {} seglocResetMainToBaseFromRflexFormatOutput
}

proc ::seglocResetMainToBaseFromRflex { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "ResetMainToBaseFromRflex" \
	"Synchronize segloc with odo. I forgot the purpose... Will probably rip.... " \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::seglocResetMainToBaseFromRflexFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocResetMainToBaseFromRflex
interp hide {} seglocResetMainToBaseFromRflexFormatOutput





# LoadMap ----------------------------------------------------------

if { [lsearch [interp hidden] seglocLoadMap] >= 0 } {
    interp expose {} seglocLoadMap
}
if { [lsearch [interp hidden] seglocLoadMapFormatOutput] >= 0 } {
    interp expose {} seglocLoadMapFormatOutput
}

proc ::seglocLoadMap { name args } {
    set format {}
    lappend format [list string "mapFile.baseName" "" ]
    lappend format [list int "mapFile.num" 0 ]
    lappend format [list int "mapFile.unused" 0 ]

    return [ ::cs::rqstSend "${name}" "LoadMap" \
	"Re-load the map." \
	"SEGLOC_FILE_PARAMS\n| char baseName\[256\]\n| int num\n| int unused\n" \
	3 \
	$format \
	$args ]
}


proc ::seglocLoadMapFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocLoadMap
interp hide {} seglocLoadMapFormatOutput





# GetMapFile ----------------------------------------------------------

if { [lsearch [interp hidden] seglocGetMapFile] >= 0 } {
    interp expose {} seglocGetMapFile
}
if { [lsearch [interp hidden] seglocGetMapFileFormatOutput] >= 0 } {
    interp expose {} seglocGetMapFileFormatOutput
}

proc ::seglocGetMapFile { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetMapFile" \
	"Returns the current map file name + number" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::seglocGetMapFileFormatOutput { list } {
    set format { {} status { } { mapFile { } baseName { } num { } unused } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocGetMapFile
interp hide {} seglocGetMapFileFormatOutput





# SaveMap ----------------------------------------------------------

if { [lsearch [interp hidden] seglocSaveMap] >= 0 } {
    interp expose {} seglocSaveMap
}
if { [lsearch [interp hidden] seglocSaveMapFormatOutput] >= 0 } {
    interp expose {} seglocSaveMapFormatOutput
}

proc ::seglocSaveMap { name args } {
    set format {}
    lappend format [list string "mapFile.baseName" "" ]
    lappend format [list int "mapFile.num" 0 ]
    lappend format [list int "mapFile.unused" 0 ]

    return [ ::cs::rqstSend "${name}" "SaveMap" \
	"Saves the map in a file" \
	"SEGLOC_FILE_PARAMS\n| char baseName\[256\]\n| int num\n| int unused\n" \
	3 \
	$format \
	$args ]
}


proc ::seglocSaveMapFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocSaveMap
interp hide {} seglocSaveMapFormatOutput





# ClipMap ----------------------------------------------------------

if { [lsearch [interp hidden] seglocClipMap] >= 0 } {
    interp expose {} seglocClipMap
}
if { [lsearch [interp hidden] seglocClipMapFormatOutput] >= 0 } {
    interp expose {} seglocClipMapFormatOutput
}

proc ::seglocClipMap { name args } {
    set format {}
    lappend format [list { "SEGLOC_REMOVE_OUT" "SEGLOC_REMOVE_IN" } "clipMapParams.clipMode" "" ]
    lappend format [list int "clipMapParams.unused" 0 ]
    lappend format [list double "clipMapParams.xmin" 0.0 ]
    lappend format [list double "clipMapParams.ymin" 0.0 ]
    lappend format [list double "clipMapParams.xmax" 0.0 ]
    lappend format [list double "clipMapParams.ymax" 0.0 ]

    return [ ::cs::rqstSend "${name}" "ClipMap" \
	"Keeps only the segments in the given rectangle" \
	"SEGLOC_CLIP_MAP_PARAMS\n| SEGLOC_CLIP_MODE clipMode\n| int unused\n| double xmin\n| double ymin\n| double xmax\n| double ymax\n" \
	6 \
	$format \
	$args ]
}


proc ::seglocClipMapFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocClipMap
interp hide {} seglocClipMapFormatOutput





# AddSegsInMap ----------------------------------------------------------

if { [lsearch [interp hidden] seglocAddSegsInMap] >= 0 } {
    interp expose {} seglocAddSegsInMap
}
if { [lsearch [interp hidden] seglocAddSegsInMapFormatOutput] >= 0 } {
    interp expose {} seglocAddSegsInMapFormatOutput
}

proc ::seglocAddSegsInMap { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "AddSegsInMap" \
	"Main function to build a map: add last acquired segments in map." \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::seglocAddSegsInMapFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocAddSegsInMap
interp hide {} seglocAddSegsInMapFormatOutput





# ResetFrame ----------------------------------------------------------

if { [lsearch [interp hidden] seglocResetFrame] >= 0 } {
    interp expose {} seglocResetFrame
}
if { [lsearch [interp hidden] seglocResetFrameFormatOutput] >= 0 } {
    interp expose {} seglocResetFrameFormatOutput
}

proc ::seglocResetFrame { name args } {
    set format {}
    lappend format [list double "changePositions.start.x" 0.0 ]
    lappend format [list double "changePositions.start.y" 0.0 ]
    lappend format [list double "changePositions.start.theta" 0.0 ]
    lappend format [list double "changePositions.end.x" 0.0 ]
    lappend format [list double "changePositions.end.y" 0.0 ]
    lappend format [list double "changePositions.end.theta" 0.0 ]

    return [ ::cs::rqstSend "${name}" "ResetFrame" \
	"Changes map frame. One has to give (x,y,th) configuration in the old frame and in the new frame" \
	"SEGLOC_START_END_POS\n| SEGLOC_POS\n| | double x\n| | double y\n| | double theta\n| SEGLOC_POS\n| | double x\n| | double y\n| | double theta\n" \
	6 \
	$format \
	$args ]
}


proc ::seglocResetFrameFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocResetFrame
interp hide {} seglocResetFrameFormatOutput





# SetNorthEnv ----------------------------------------------------------

if { [lsearch [interp hidden] seglocSetNorthEnv] >= 0 } {
    interp expose {} seglocSetNorthEnv
}
if { [lsearch [interp hidden] seglocSetNorthEnvFormatOutput] >= 0 } {
    interp expose {} seglocSetNorthEnvFormatOutput
}

proc ::seglocSetNorthEnv { name args } {
    set format {}
    lappend format [list double "compassEnv.environmentNorthDeg" 0.0 ]
    lappend format [list double "compassEnv.environmentAccuracyDeg" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetNorthEnv" \
	"To define the NORTH of the environment (useful with the compass)" \
	"SEGLOC_COMPASS_ENV\n| double environmentNorthDeg\n| double environmentAccuracyDeg\n" \
	2 \
	$format \
	$args ]
}


proc ::seglocSetNorthEnvFormatOutput { list } {
    set format { {} status { } { compassRes { } nbData { } unused { } rawAngleDeg { } correctedAngleDeg { } angleUncDeg { } deltaAngleAverageDeg { } deltaAngleSquareAverageRad { } deltaAngle3sigmaDeg { } deltaAngleMinDeg { } deltaAngleMaxDeg } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocSetNorthEnv
interp hide {} seglocSetNorthEnvFormatOutput





# RemoveSegment ----------------------------------------------------------

if { [lsearch [interp hidden] seglocRemoveSegment] >= 0 } {
    interp expose {} seglocRemoveSegment
}
if { [lsearch [interp hidden] seglocRemoveSegmentFormatOutput] >= 0 } {
    interp expose {} seglocRemoveSegmentFormatOutput
}

proc ::seglocRemoveSegment { name args } {
    set format {}
    lappend format [list double "seg1.x1" 0.0 ]
    lappend format [list double "seg1.y1" 0.0 ]
    lappend format [list double "seg1.x2" 0.0 ]
    lappend format [list double "seg1.y2" 0.0 ]

    return [ ::cs::rqstSend "${name}" "RemoveSegment" \
	"Removes a segment given its exact coordinates (difficult to use by hand !). Usefull with seglocEdit grh2 interface." \
	"SEGLOC_SEG\n| double x1\n| double y1\n| double x2\n| double y2\n" \
	4 \
	$format \
	$args ]
}


proc ::seglocRemoveSegmentFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocRemoveSegment
interp hide {} seglocRemoveSegmentFormatOutput





# MergeSegments ----------------------------------------------------------

if { [lsearch [interp hidden] seglocMergeSegments] >= 0 } {
    interp expose {} seglocMergeSegments
}
if { [lsearch [interp hidden] seglocMergeSegmentsFormatOutput] >= 0 } {
    interp expose {} seglocMergeSegmentsFormatOutput
}

proc ::seglocMergeSegments { name args } {
    set format {}
    lappend format [list double "segs.seg1.x1" 0.0 ]
    lappend format [list double "segs.seg1.y1" 0.0 ]
    lappend format [list double "segs.seg1.x2" 0.0 ]
    lappend format [list double "segs.seg1.y2" 0.0 ]
    lappend format [list double "segs.seg2.x1" 0.0 ]
    lappend format [list double "segs.seg2.y1" 0.0 ]
    lappend format [list double "segs.seg2.x2" 0.0 ]
    lappend format [list double "segs.seg2.y2" 0.0 ]

    return [ ::cs::rqstSend "${name}" "MergeSegments" \
	"Force segments merging. Usefull with seglocEdit grh2 interface." \
	"SEGLOC_2SEGS\n| SEGLOC_SEG\n| | double x1\n| | double y1\n| | double x2\n| | double y2\n| SEGLOC_SEG\n| | double x1\n| | double y1\n| | double x2\n| | double y2\n" \
	8 \
	$format \
	$args ]
}


proc ::seglocMergeSegmentsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocMergeSegments
interp hide {} seglocMergeSegmentsFormatOutput





# IntersectSegments ----------------------------------------------------------

if { [lsearch [interp hidden] seglocIntersectSegments] >= 0 } {
    interp expose {} seglocIntersectSegments
}
if { [lsearch [interp hidden] seglocIntersectSegmentsFormatOutput] >= 0 } {
    interp expose {} seglocIntersectSegmentsFormatOutput
}

proc ::seglocIntersectSegments { name args } {
    set format {}
    lappend format [list double "segs.seg1.x1" 0.0 ]
    lappend format [list double "segs.seg1.y1" 0.0 ]
    lappend format [list double "segs.seg1.x2" 0.0 ]
    lappend format [list double "segs.seg1.y2" 0.0 ]
    lappend format [list double "segs.seg2.x1" 0.0 ]
    lappend format [list double "segs.seg2.y1" 0.0 ]
    lappend format [list double "segs.seg2.x2" 0.0 ]
    lappend format [list double "segs.seg2.y2" 0.0 ]

    return [ ::cs::rqstSend "${name}" "IntersectSegments" \
	"Force segments nice intersection. Usefull with seglocEdit grh2 interface." \
	"SEGLOC_2SEGS\n| SEGLOC_SEG\n| | double x1\n| | double y1\n| | double x2\n| | double y2\n| SEGLOC_SEG\n| | double x1\n| | double y1\n| | double x2\n| | double y2\n" \
	8 \
	$format \
	$args ]
}


proc ::seglocIntersectSegmentsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocIntersectSegments
interp hide {} seglocIntersectSegmentsFormatOutput





# CutSegment ----------------------------------------------------------

if { [lsearch [interp hidden] seglocCutSegment] >= 0 } {
    interp expose {} seglocCutSegment
}
if { [lsearch [interp hidden] seglocCutSegmentFormatOutput] >= 0 } {
    interp expose {} seglocCutSegmentFormatOutput
}

proc ::seglocCutSegment { name args } {
    set format {}
    lappend format [list double "segCut.seg.x1" 0.0 ]
    lappend format [list double "segCut.seg.y1" 0.0 ]
    lappend format [list double "segCut.seg.x2" 0.0 ]
    lappend format [list double "segCut.seg.y2" 0.0 ]
    lappend format [list double "segCut.l1" 0.0 ]
    lappend format [list double "segCut.l2" 0.0 ]

    return [ ::cs::rqstSend "${name}" "CutSegment" \
	"Reduces the length of a segment (for instance to open a closed door in a wall...)." \
	"SEGLOC_CUT_SEG\n| SEGLOC_SEG\n| | double x1\n| | double y1\n| | double x2\n| | double y2\n| double l1\n| double l2\n" \
	6 \
	$format \
	$args ]
}


proc ::seglocCutSegmentFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocCutSegment
interp hide {} seglocCutSegmentFormatOutput





# SetOfflineMode ----------------------------------------------------------

if { [lsearch [interp hidden] seglocSetOfflineMode] >= 0 } {
    interp expose {} seglocSetOfflineMode
}
if { [lsearch [interp hidden] seglocSetOfflineModeFormatOutput] >= 0 } {
    interp expose {} seglocSetOfflineModeFormatOutput
}

proc ::seglocSetOfflineMode { name args } {
    set format {}
    lappend format [list { "SEGLOC_TRUE" "SEGLOC_FALSE" } "offlineParams.offlineOn" "" ]
    lappend format [list { "SEGLOC_TRUE" "SEGLOC_FALSE" } "offlineParams.setSegmentationOff" "" ]
    lappend format [list string "offlineParams.baseName" "" ]
    lappend format [list int "offlineParams.fileNum" 0 ]
    lappend format [list { "SEGLOC_TRUE" "SEGLOC_FALSE" } "offlineParams.readPrevClassif" "" ]

    return [ ::cs::rqstSend "${name}" "SetOfflineMode" \
	"Segloc uses sick data saved in files instead of read from a poster. The SICK module can produces such files." \
	"SEGLOC_OFFLINE\n| SEGLOC_BOOL offlineOn\n| SEGLOC_BOOL setSegmentationOff\n| char baseName\[256\]\n| int fileNum\n| SEGLOC_BOOL readPrevClassif\n" \
	5 \
	$format \
	$args ]
}


proc ::seglocSetOfflineModeFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocSetOfflineMode
interp hide {} seglocSetOfflineModeFormatOutput





# GetOfflineModeParams ----------------------------------------------------------

if { [lsearch [interp hidden] seglocGetOfflineModeParams] >= 0 } {
    interp expose {} seglocGetOfflineModeParams
}
if { [lsearch [interp hidden] seglocGetOfflineModeParamsFormatOutput] >= 0 } {
    interp expose {} seglocGetOfflineModeParamsFormatOutput
}

proc ::seglocGetOfflineModeParams { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetOfflineModeParams" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::seglocGetOfflineModeParamsFormatOutput { list } {
    set format { {} status { } { offlineParams { } offlineOn { } setSegmentationOff { } baseName { } fileNum { } readPrevClassif } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocGetOfflineModeParams
interp hide {} seglocGetOfflineModeParamsFormatOutput





# LocTransf ----------------------------------------------------------

if { [lsearch [interp hidden] seglocLocTransfPosterRead] >= 0 } {
    interp expose {} seglocLocTransfPosterRead
}
if { [lsearch [interp hidden] seglocLocTransfPosterFormatOutput] >= 0 } {
    interp expose {} seglocLocTransfPosterFormatOutput
}

proc ::seglocLocTransfPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "LocTransf" \
	"SEGLOC_POS_VAR\n| SEGLOC_POS\n| | double x\n| | double y\n| | double theta\n| SEGLOC_VARIANCES\n| | double vxx\n| | double vyy\n| | double vtt\n| | double vxy\n| | double vxt\n| | double vyt\n" \
	$args ]
}


proc ::seglocLocTransfPosterFormatOutput { list } {
    set format { {} status { } { Transf { } { pos { } x { } y { } theta } { } { var { } vxx { } vyy { } vtt { } vxy { } vxt { } vyt } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocLocTransfPosterRead
interp hide {} seglocLocTransfPosterFormatOutput





# LocReport ----------------------------------------------------------

if { [lsearch [interp hidden] seglocLocReportPosterRead] >= 0 } {
    interp expose {} seglocLocReportPosterRead
}
if { [lsearch [interp hidden] seglocLocReportPosterFormatOutput] >= 0 } {
    interp expose {} seglocLocReportPosterFormatOutput
}

proc ::seglocLocReportPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "LocReport" \
	"SEGLOC_LOC_REPORT\n| SEGLOC_LOC_QUALITY quality\n| int nbPossibilities\n| int nbSuccesses\n| int nbMatches\n| double confidence\n" \
	$args ]
}


proc ::seglocLocReportPosterFormatOutput { list } {
    set format { {} status { } { Report { } quality { } nbPossibilities { } nbSuccesses { } nbMatches { } confidence } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocLocReportPosterRead
interp hide {} seglocLocReportPosterFormatOutput





# MiscSickLocoPos ----------------------------------------------------------

if { [lsearch [interp hidden] seglocMiscSickLocoPosPosterRead] >= 0 } {
    interp expose {} seglocMiscSickLocoPosPosterRead
}
if { [lsearch [interp hidden] seglocMiscSickLocoPosPosterFormatOutput] >= 0 } {
    interp expose {} seglocMiscSickLocoPosPosterFormatOutput
}

proc ::seglocMiscSickLocoPosPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "MiscSickLocoPos" \
	"SEGLOC_POS_VAR_SPEED\n| SEGLOC_POS\n| | double x\n| | double y\n| | double theta\n| SEGLOC_VARIANCES\n| | double vxx\n| | double vyy\n| | double vtt\n| | double vxy\n| | double vxt\n| | double vyt\n| SEGLOC_SPEED\n| | double v\n| | double w\n" \
	$args ]
}


proc ::seglocMiscSickLocoPosPosterFormatOutput { list } {
    set format { {} status { } { SickLocoPos { } { pos { } x { } y { } theta } { } { var { } vxx { } vyy { } vtt { } vxy { } vxt { } vyt } { } { speed { } v { } w } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocMiscSickLocoPosPosterRead
interp hide {} seglocMiscSickLocoPosPosterFormatOutput





# MiscSickSeglocPos ----------------------------------------------------------

if { [lsearch [interp hidden] seglocMiscSickSeglocPosPosterRead] >= 0 } {
    interp expose {} seglocMiscSickSeglocPosPosterRead
}
if { [lsearch [interp hidden] seglocMiscSickSeglocPosPosterFormatOutput] >= 0 } {
    interp expose {} seglocMiscSickSeglocPosPosterFormatOutput
}

proc ::seglocMiscSickSeglocPosPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "MiscSickSeglocPos" \
	"SEGLOC_POS_VAR\n| SEGLOC_POS\n| | double x\n| | double y\n| | double theta\n| SEGLOC_VARIANCES\n| | double vxx\n| | double vyy\n| | double vtt\n| | double vxy\n| | double vxt\n| | double vyt\n" \
	$args ]
}


proc ::seglocMiscSickSeglocPosPosterFormatOutput { list } {
    set format { {} status { } { SickSeglocPos { } { pos { } x { } y { } theta } { } { var { } vxx { } vyy { } vtt { } vxy { } vxt { } vyt } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocMiscSickSeglocPosPosterRead
interp hide {} seglocMiscSickSeglocPosPosterFormatOutput





# MiscCurrentLocoPos ----------------------------------------------------------

if { [lsearch [interp hidden] seglocMiscCurrentLocoPosPosterRead] >= 0 } {
    interp expose {} seglocMiscCurrentLocoPosPosterRead
}
if { [lsearch [interp hidden] seglocMiscCurrentLocoPosPosterFormatOutput] >= 0 } {
    interp expose {} seglocMiscCurrentLocoPosPosterFormatOutput
}

proc ::seglocMiscCurrentLocoPosPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "MiscCurrentLocoPos" \
	"SEGLOC_POS_VAR_SPEED\n| SEGLOC_POS\n| | double x\n| | double y\n| | double theta\n| SEGLOC_VARIANCES\n| | double vxx\n| | double vyy\n| | double vtt\n| | double vxy\n| | double vxt\n| | double vyt\n| SEGLOC_SPEED\n| | double v\n| | double w\n" \
	$args ]
}


proc ::seglocMiscCurrentLocoPosPosterFormatOutput { list } {
    set format { {} status { } { CurrentLocoPos { } { pos { } x { } y { } theta } { } { var { } vxx { } vyy { } vtt { } vxy { } vxt { } vyt } { } { speed { } v { } w } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocMiscCurrentLocoPosPosterRead
interp hide {} seglocMiscCurrentLocoPosPosterFormatOutput





# MiscCurrentSeglocPos ----------------------------------------------------------

if { [lsearch [interp hidden] seglocMiscCurrentSeglocPosPosterRead] >= 0 } {
    interp expose {} seglocMiscCurrentSeglocPosPosterRead
}
if { [lsearch [interp hidden] seglocMiscCurrentSeglocPosPosterFormatOutput] >= 0 } {
    interp expose {} seglocMiscCurrentSeglocPosPosterFormatOutput
}

proc ::seglocMiscCurrentSeglocPosPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "MiscCurrentSeglocPos" \
	"SEGLOC_POS_VAR\n| SEGLOC_POS\n| | double x\n| | double y\n| | double theta\n| SEGLOC_VARIANCES\n| | double vxx\n| | double vyy\n| | double vtt\n| | double vxy\n| | double vxt\n| | double vyt\n" \
	$args ]
}


proc ::seglocMiscCurrentSeglocPosPosterFormatOutput { list } {
    set format { {} status { } { CurrentSeglocPos { } { pos { } x { } y { } theta } { } { var { } vxx { } vyy { } vtt { } vxy { } vxt { } vyt } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocMiscCurrentSeglocPosPosterRead
interp hide {} seglocMiscCurrentSeglocPosPosterFormatOutput





# MiscseglocTimes ----------------------------------------------------------

if { [lsearch [interp hidden] seglocMiscseglocTimesPosterRead] >= 0 } {
    interp expose {} seglocMiscseglocTimesPosterRead
}
if { [lsearch [interp hidden] seglocMiscseglocTimesPosterFormatOutput] >= 0 } {
    interp expose {} seglocMiscseglocTimesPosterFormatOutput
}

proc ::seglocMiscseglocTimesPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "MiscseglocTimes" \
	"SEGLOC_TIMES\n| unsigned int sickTime\n| unsigned int transfUpdateTime\n| unsigned int lastlocTime\n| int unused\n" \
	$args ]
}


proc ::seglocMiscseglocTimesPosterFormatOutput { list } {
    set format { {} status { } { seglocTimes { } sickTime { } transfUpdateTime { } lastlocTime { } unused } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocMiscseglocTimesPosterRead
interp hide {} seglocMiscseglocTimesPosterFormatOutput





# MiscSickLocoUncertainties ----------------------------------------------------------

if { [lsearch [interp hidden] seglocMiscSickLocoUncertaintiesPosterRead] >= 0 } {
    interp expose {} seglocMiscSickLocoUncertaintiesPosterRead
}
if { [lsearch [interp hidden] seglocMiscSickLocoUncertaintiesPosterFormatOutput] >= 0 } {
    interp expose {} seglocMiscSickLocoUncertaintiesPosterFormatOutput
}

proc ::seglocMiscSickLocoUncertaintiesPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "MiscSickLocoUncertainties" \
	"SEGLOC_UNC\n| double ux\n| double uy\n| double utheta\n" \
	$args ]
}


proc ::seglocMiscSickLocoUncertaintiesPosterFormatOutput { list } {
    set format { {} status { } { SickLocoUncertainties { } ux { } uy { } utheta } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocMiscSickLocoUncertaintiesPosterRead
interp hide {} seglocMiscSickLocoUncertaintiesPosterFormatOutput





# MiscSickSeglocUncertainties ----------------------------------------------------------

if { [lsearch [interp hidden] seglocMiscSickSeglocUncertaintiesPosterRead] >= 0 } {
    interp expose {} seglocMiscSickSeglocUncertaintiesPosterRead
}
if { [lsearch [interp hidden] seglocMiscSickSeglocUncertaintiesPosterFormatOutput] >= 0 } {
    interp expose {} seglocMiscSickSeglocUncertaintiesPosterFormatOutput
}

proc ::seglocMiscSickSeglocUncertaintiesPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "MiscSickSeglocUncertainties" \
	"SEGLOC_UNC\n| double ux\n| double uy\n| double utheta\n" \
	$args ]
}


proc ::seglocMiscSickSeglocUncertaintiesPosterFormatOutput { list } {
    set format { {} status { } { SickSeglocUncertainties { } ux { } uy { } utheta } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocMiscSickSeglocUncertaintiesPosterRead
interp hide {} seglocMiscSickSeglocUncertaintiesPosterFormatOutput





# MiscStat ----------------------------------------------------------

if { [lsearch [interp hidden] seglocMiscStatPosterRead] >= 0 } {
    interp expose {} seglocMiscStatPosterRead
}
if { [lsearch [interp hidden] seglocMiscStatPosterFormatOutput] >= 0 } {
    interp expose {} seglocMiscStatPosterFormatOutput
}

proc ::seglocMiscStatPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "MiscStat" \
	"SEGLOC_STAT\n| int nbLocOK\n| int nbPartialLoc\n| int nbLocFailed\n| int nbLocCrashed\n" \
	$args ]
}


proc ::seglocMiscStatPosterFormatOutput { list } {
    set format { {} status { } { Stat { } nbLocOK { } nbPartialLoc { } nbLocFailed { } nbLocCrashed } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocMiscStatPosterRead
interp hide {} seglocMiscStatPosterFormatOutput





# MiscCompass ----------------------------------------------------------

if { [lsearch [interp hidden] seglocMiscCompassPosterRead] >= 0 } {
    interp expose {} seglocMiscCompassPosterRead
}
if { [lsearch [interp hidden] seglocMiscCompassPosterFormatOutput] >= 0 } {
    interp expose {} seglocMiscCompassPosterFormatOutput
}

proc ::seglocMiscCompassPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "MiscCompass" \
	"SEGLOC_COMPASS_STR\n| SEGLOC_COMPASS_ENV\n| | double environmentNorthDeg\n| | double environmentAccuracyDeg\n| SEGLOC_COMPASS_RES\n| | int nbData\n| | int unused\n| | double rawAngleDeg\n| | double correctedAngleDeg\n| | double angleUncDeg\n| | double deltaAngleAverageDeg\n| | double deltaAngleSquareAverageRad\n| | double deltaAngle3sigmaDeg\n| | double deltaAngleMinDeg\n| | double deltaAngleMaxDeg\n" \
	$args ]
}


proc ::seglocMiscCompassPosterFormatOutput { list } {
    set format { {} status { } { Compass { } { compassEnv { } environmentNorthDeg { } environmentAccuracyDeg } { } { compassRes { } nbData { } unused { } rawAngleDeg { } correctedAngleDeg { } angleUncDeg { } deltaAngleAverageDeg { } deltaAngleSquareAverageRad { } deltaAngle3sigmaDeg { } deltaAngleMinDeg { } deltaAngleMaxDeg } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocMiscCompassPosterRead
interp hide {} seglocMiscCompassPosterFormatOutput





# MEPosPos ----------------------------------------------------------

if { [lsearch [interp hidden] seglocMEPosPosPosterRead] >= 0 } {
    interp expose {} seglocMEPosPosPosterRead
}
if { [lsearch [interp hidden] seglocMEPosPosPosterFormatOutput] >= 0 } {
    interp expose {} seglocMEPosPosPosterFormatOutput
}

proc ::seglocMEPosPosPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "MEPosPos" \
	"POM_ME_POS\n| POM_ME_CLASS kind\n| int unused\n| double confidence\n| int date1\n| int date2\n| POM_EULER_V\n| | POM_EULER\n| | | double yaw\n| | | double pitch\n| | | double roll\n| | | double x\n| | | double y\n| | | double z\n| | POM_EULER_VARIANCES\n| | | double voo\n| | | double vop\n| | | double vpp\n| | | double vor\n| | | double vpr\n| | | double vrr\n| | | double vox\n| | | double vpx\n| | | double vrx\n| | | double vxx\n| | | double voy\n| | | double vpy\n| | | double vry\n| | | double vxy\n| | | double vyy\n| | | double voz\n| | | double vpz\n| | | double vrz\n| | | double vxz\n| | | double vyz\n| | | double vzz\n| POM_EULER_V\n| | POM_EULER\n| | | double yaw\n| | | double pitch\n| | | double roll\n| | | double x\n| | | double y\n| | | double z\n| | POM_EULER_VARIANCES\n| | | double voo\n| | | double vop\n| | | double vpp\n| | | double vor\n| | | double vpr\n| | | double vrr\n| | | double vox\n| | | double vpx\n| | | double vrx\n| | | double vxx\n| | | double voy\n| | | double vpy\n| | | double vry\n| | | double vxy\n| | | double vyy\n| | | double voz\n| | | double vpz\n| | | double vrz\n| | | double vxz\n| | | double vyz\n| | | double vzz\n" \
	$args ]
}


proc ::seglocMEPosPosPosterFormatOutput { list } {
    set format { {} status { } { Pos { } kind { } unused { } confidence { } date1 { } date2 { } { main { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { VLocal { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocMEPosPosPosterRead
interp hide {} seglocMEPosPosPosterFormatOutput





# MapMap ----------------------------------------------------------

if { [lsearch [interp hidden] seglocMapMapPosterRead] >= 0 } {
    interp expose {} seglocMapMapPosterRead
}
if { [lsearch [interp hidden] seglocMapMapPosterFormatOutput] >= 0 } {
    interp expose {} seglocMapMapPosterFormatOutput
}

proc ::seglocMapMapPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "MapMap" \
	"SEGLOC_MAP\n| SEGLOC_MAP_HEADER\n| | int nbSegs\n| | int mapNum\n| | SEGLOC_POS\n| | | double x\n| | | double y\n| | | double theta\n| | char envName\[64\]\n| SEGLOC_SEG\n| | double x1\n| | double y1\n| | double x2\n| | double y2\n" \
	$args ]
}


proc ::seglocMapMapPosterFormatOutput { list } {
    set format { {} status { } { Map { } { header { } nbSegs { } mapNum { } { pos { } x { } y { } theta } { } envName } { 1000 } { segs { } x1 { } y1 { } x2 { } y2 } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocMapMapPosterRead
interp hide {} seglocMapMapPosterFormatOutput





# SegsSegs ----------------------------------------------------------

if { [lsearch [interp hidden] seglocSegsSegsPosterRead] >= 0 } {
    interp expose {} seglocSegsSegsPosterRead
}
if { [lsearch [interp hidden] seglocSegsSegsPosterFormatOutput] >= 0 } {
    interp expose {} seglocSegsSegsPosterFormatOutput
}

proc ::seglocSegsSegsPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "SegsSegs" \
	"SEGLOC_ACQ_SEGS\n| SEGLOC_SEG_HEADER\n| | int nbSegs\n| | SEGLOC_BOOL variancesUpdated\n| | SEGLOC_POS\n| | | double x\n| | | double y\n| | | double theta\n| | unsigned int sickTime\n| | int nbMatchSegs\n| | SEGLOC_VARIANCES\n| | | double vxx\n| | | double vyy\n| | | double vtt\n| | | double vxy\n| | | double vxt\n| | | double vyt\n| | POM_SENSOR_POS\n| | | int date\n| | | int pad\n| | | POM_EULER_V\n| | | | POM_EULER\n| | | | | double yaw\n| | | | | double pitch\n| | | | | double roll\n| | | | | double x\n| | | | | double y\n| | | | | double z\n| | | | POM_EULER_VARIANCES\n| | | | | double voo\n| | | | | double vop\n| | | | | double vpp\n| | | | | double vor\n| | | | | double vpr\n| | | | | double vrr\n| | | | | double vox\n| | | | | double vpx\n| | | | | double vrx\n| | | | | double vxx\n| | | | | double voy\n| | | | | double vpy\n| | | | | double vry\n| | | | | double vxy\n| | | | | double vyy\n| | | | | double voz\n| | | | | double vpz\n| | | | | double vrz\n| | | | | double vxz\n| | | | | double vyz\n| | | | | double vzz\n| | | POM_EULER_V\n| | | | POM_EULER\n| | | | | double yaw\n| | | | | double pitch\n| | | | | double roll\n| | | | | double x\n| | | | | double y\n| | | | | double z\n| | | | POM_EULER_VARIANCES\n| | | | | double voo\n| | | | | double vop\n| | | | | double vpp\n| | | | | double vor\n| | | | | double vpr\n| | | | | double vrr\n| | | | | double vox\n| | | | | double vpx\n| | | | | double vrx\n| | | | | double vxx\n| | | | | double voy\n| | | | | double vpy\n| | | | | double vry\n| | | | | double vxy\n| | | | | double vyy\n| | | | | double voz\n| | | | | double vpz\n| | | | | double vrz\n| | | | | double vxz\n| | | | | double vyz\n| | | | | double vzz\n| | | POM_EULER_V\n| | | | POM_EULER\n| | | | | double yaw\n| | | | | double pitch\n| | | | | double roll\n| | | | | double x\n| | | | | double y\n| | | | | double z\n| | | | POM_EULER_VARIANCES\n| | | | | double voo\n| | | | | double vop\n| | | | | double vpp\n| | | | | double vor\n| | | | | double vpr\n| | | | | double vrr\n| | | | | double vox\n| | | | | double vpx\n| | | | | double vrx\n| | | | | double vxx\n| | | | | double voy\n| | | | | double vpy\n| | | | | double vry\n| | | | | double vxy\n| | | | | double vyy\n| | | | | double voz\n| | | | | double vpz\n| | | | | double vrz\n| | | | | double vxz\n| | | | | double vyz\n| | | | | double vzz\n| | | POM_EULER_V\n| | | | POM_EULER\n| | | | | double yaw\n| | | | | double pitch\n| | | | | double roll\n| | | | | double x\n| | | | | double y\n| | | | | double z\n| | | | POM_EULER_VARIANCES\n| | | | | double voo\n| | | | | double vop\n| | | | | double vpp\n| | | | | double vor\n| | | | | double vpr\n| | | | | double vrr\n| | | | | double vox\n| | | | | double vpx\n| | | | | double vrx\n| | | | | double vxx\n| | | | | double voy\n| | | | | double vpy\n| | | | | double vry\n| | | | | double vxy\n| | | | | double vyy\n| | | | | double voz\n| | | | | double vpz\n| | | | | double vrz\n| | | | | double vxz\n| | | | | double vyz\n| | | | | double vzz\n| SEGLOC_SEG\n| | double x1\n| | double y1\n| | double x2\n| | double y2\n" \
	$args ]
}


proc ::seglocSegsSegsPosterFormatOutput { list } {
    set format { {} status { } { Segs { } { header { } nbSegs { } variancesUpdated { } { locoPos { } x { } y { } theta } { } sickTime { } nbMatchSegs { } { variances { } vxx { } vyy { } vtt { } vxy { } vxt { } vyt } { } { sickPomPos { } date { } pad { } { sensorToMain { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { mainToBase { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { mainToOrigin { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { VLocal { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } } } { 100 } { segs { } x1 { } y1 { } x2 { } y2 } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocSegsSegsPosterRead
interp hide {} seglocSegsSegsPosterFormatOutput





# AspectAspect ----------------------------------------------------------

if { [lsearch [interp hidden] seglocAspectAspectPosterRead] >= 0 } {
    interp expose {} seglocAspectAspectPosterRead
}
if { [lsearch [interp hidden] seglocAspectAspectPosterFormatOutput] >= 0 } {
    interp expose {} seglocAspectAspectPosterFormatOutput
}

proc ::seglocAspectAspectPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "AspectAspect" \
	"SEGLOC_ASPECT_SEGS\n| SEGLOC_SEG_HEADER\n| | int nbSegs\n| | SEGLOC_BOOL variancesUpdated\n| | SEGLOC_POS\n| | | double x\n| | | double y\n| | | double theta\n| | unsigned int sickTime\n| | int nbMatchSegs\n| | SEGLOC_VARIANCES\n| | | double vxx\n| | | double vyy\n| | | double vtt\n| | | double vxy\n| | | double vxt\n| | | double vyt\n| | POM_SENSOR_POS\n| | | int date\n| | | int pad\n| | | POM_EULER_V\n| | | | POM_EULER\n| | | | | double yaw\n| | | | | double pitch\n| | | | | double roll\n| | | | | double x\n| | | | | double y\n| | | | | double z\n| | | | POM_EULER_VARIANCES\n| | | | | double voo\n| | | | | double vop\n| | | | | double vpp\n| | | | | double vor\n| | | | | double vpr\n| | | | | double vrr\n| | | | | double vox\n| | | | | double vpx\n| | | | | double vrx\n| | | | | double vxx\n| | | | | double voy\n| | | | | double vpy\n| | | | | double vry\n| | | | | double vxy\n| | | | | double vyy\n| | | | | double voz\n| | | | | double vpz\n| | | | | double vrz\n| | | | | double vxz\n| | | | | double vyz\n| | | | | double vzz\n| | | POM_EULER_V\n| | | | POM_EULER\n| | | | | double yaw\n| | | | | double pitch\n| | | | | double roll\n| | | | | double x\n| | | | | double y\n| | | | | double z\n| | | | POM_EULER_VARIANCES\n| | | | | double voo\n| | | | | double vop\n| | | | | double vpp\n| | | | | double vor\n| | | | | double vpr\n| | | | | double vrr\n| | | | | double vox\n| | | | | double vpx\n| | | | | double vrx\n| | | | | double vxx\n| | | | | double voy\n| | | | | double vpy\n| | | | | double vry\n| | | | | double vxy\n| | | | | double vyy\n| | | | | double voz\n| | | | | double vpz\n| | | | | double vrz\n| | | | | double vxz\n| | | | | double vyz\n| | | | | double vzz\n| | | POM_EULER_V\n| | | | POM_EULER\n| | | | | double yaw\n| | | | | double pitch\n| | | | | double roll\n| | | | | double x\n| | | | | double y\n| | | | | double z\n| | | | POM_EULER_VARIANCES\n| | | | | double voo\n| | | | | double vop\n| | | | | double vpp\n| | | | | double vor\n| | | | | double vpr\n| | | | | double vrr\n| | | | | double vox\n| | | | | double vpx\n| | | | | double vrx\n| | | | | double vxx\n| | | | | double voy\n| | | | | double vpy\n| | | | | double vry\n| | | | | double vxy\n| | | | | double vyy\n| | | | | double voz\n| | | | | double vpz\n| | | | | double vrz\n| | | | | double vxz\n| | | | | double vyz\n| | | | | double vzz\n| | | POM_EULER_V\n| | | | POM_EULER\n| | | | | double yaw\n| | | | | double pitch\n| | | | | double roll\n| | | | | double x\n| | | | | double y\n| | | | | double z\n| | | | POM_EULER_VARIANCES\n| | | | | double voo\n| | | | | double vop\n| | | | | double vpp\n| | | | | double vor\n| | | | | double vpr\n| | | | | double vrr\n| | | | | double vox\n| | | | | double vpx\n| | | | | double vrx\n| | | | | double vxx\n| | | | | double voy\n| | | | | double vpy\n| | | | | double vry\n| | | | | double vxy\n| | | | | double vyy\n| | | | | double voz\n| | | | | double vpz\n| | | | | double vrz\n| | | | | double vxz\n| | | | | double vyz\n| | | | | double vzz\n| SEGLOC_SEG\n| | double x1\n| | double y1\n| | double x2\n| | double y2\n" \
	$args ]
}


proc ::seglocAspectAspectPosterFormatOutput { list } {
    set format { {} status { } { Aspect { } { header { } nbSegs { } variancesUpdated { } { locoPos { } x { } y { } theta } { } sickTime { } nbMatchSegs { } { variances { } vxx { } vyy { } vtt { } vxy { } vxt { } vyt } { } { sickPomPos { } date { } pad { } { sensorToMain { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { mainToBase { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { mainToOrigin { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { VLocal { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } } } { 100 } { segs { } x1 { } y1 { } x2 { } y2 } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} seglocAspectAspectPosterRead
interp hide {} seglocAspectAspectPosterFormatOutput


